unit RMakerU;

//NOTE: RMaker is a strictly utilitarian program that I used to
//  create RegistryRobot's data files. It works well enough, but has
//  no help (hey, *I* know how to use it!), and is rough around
//  the edges. If you must play with it, I strongly recommend backing
//  up the original data.xml and twks.xml files first.

// Copyright  2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, DBCtrls, Mask, ExtCtrls, DB, dbcgrids, Menus,
  StdActns, ExtActns, ActnList;

type
  TOneData = record
    TwkID      : Integer;
    Root       : String;
    Key        : String;
    Value      : String;
    DataType   : Integer;
    ChangeType : Integer;
    Special    : String;
    Data       : String;
    VerMask    : Integer;
  end;

  TOneTip = record
    Category    : String;
    SubCat      : String;
    Title       : String;
    Description : String;
  end;

  TMakeForm = class(TForm)
    gbTree: TGroupBox;
    tv1: TTreeView;
    pnlBase: TPanel;
    Splitter1: TSplitter;
    DBNavigator1: TDBNavigator;
    pnlTip: TPanel;
    Splitter2: TSplitter;
    pnlfields: TPanel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBText1: TDBText;
    Label1: TLabel;
    Splitter3: TSplitter;
    DBCtrlGrid1: TDBCtrlGrid;
    DBComboBox1: TDBComboBox;
    DBEdit4: TDBEdit;
    DBComboBox2: TDBComboBox;
    DBEdit5: TDBEdit;
    DBComboBox3: TDBComboBox;
    DBEdit6: TDBEdit;
    DBComboBox4: TDBComboBox;
    DBEdit7: TDBEdit;
    pEmpty: TPopupMenu;
    DBNavigator2: TDBNavigator;
    PopupMenu2: TPopupMenu;
    N0none1String2Expand3Binary4DWORD1: TMenuItem;
    String11: TMenuItem;
    Expand21: TMenuItem;
    Binary31: TMenuItem;
    DWORD41: TMenuItem;
    PopupMenu3: TPopupMenu;
    N0Addkey1Addchangevalue2Deletekey3Deletevalue4Viewvalue1: TMenuItem;
    Addchangevalue11: TMenuItem;
    Deletekey21: TMenuItem;
    Deletevalue31: TMenuItem;
    Viewvalue41: TMenuItem;
    DBMemo1: TDBMemo;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tv1Change(Sender: TObject; Node: TTreeNode);
    procedure DBEdit7ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure DWORD41Click(Sender: TObject);
    procedure Viewvalue41Click(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    First : Boolean;
    HeldID : Integer;
    OD : TOneData;
    OT : TOneTip;
    ininame : String;
    procedure LoadTree;
    procedure cdsTipsAfterThing(DataSet: TDataSet);
    procedure cdsDataBeforeInsert(DataSet: TDataSet);
    procedure cdsDataAfterInsert(DataSet: TDataSet);
    procedure cdsTipsBeforeInsert(DataSet: TDataSet);
    procedure cdsTipsAfterInsert(DataSet: TDataSet);
  public
    { Public declarations }
  end;

var
  MakeForm: TMakeForm;

implementation

uses datau, platu, inifiles;

{$R *.dfm}

procedure TMakeForm.LoadTree;
VAR
  TScat, TSsub, TSttl : TStringList;
  S  : String;
  TwkID : Integer;
  Icat, Isub, Ittl : Integer;
  root, Tcat, Tsub, Tttl : TTreeNode;
  allMask : DWord;
  hasUndo : Boolean;
begin
  dbCtrlGrid1.Visible := False;
  tv1.Items.Clear;
  root := tv1.Items.Add(nil, 'Categories');
  TScat := TStringList.Create;
  TScat.Sorted := True;
  try
    WITH dm1.cdsTwks DO
      begin
        First;
        WHILE NOT EoF DO
          begin
            TwkID := FieldByName('TwkID').AsInteger;
            WITH dm1.cdsUndo DO
              begin
                First;
                HasUndo := NOT EoF;
              end;
            allMask := 0;
            WITH dm1.cdsData DO
              begin
                First;
                WHILE NOT EoF DO
                  begin
                    allMask := allMask OR DWORD(FieldByName('VerMask').AsInteger);
                    Next;
                  end;
              end;
            S := FieldByName('Category').Text;
            Icat := TScat.IndexOf(S);
            IF Icat < 0 THEN
              begin
                TSsub := TStringList.Create;
                TSsub.Sorted := True;
                Icat := TScat.AddObject(S, TSsub);
              end
            ELSE TSSub := TStringList(TScat.Objects[ICat]);
            S := FieldByName('SubCat').Text;
            Isub := TSsub.IndexOf(S);
            IF Isub < 0 THEN
              begin
                TSttl := TStringList.Create;
                TSttl.Sorted := True;
                TSttl.Duplicates := dupAccept; //TODO: Right?
                Isub := TSsub.AddObject(S, TSttl);
              end
            ELSE TSttl := TStringList(TSsub.Objects[Isub]);
            S := FieldByName('Title').Text;
            TSttl.AddObject(S,Pointer(TwkID));
            Next;
          end;
      end;
    FOR Icat := 0 TO TScat.Count-1 DO
      begin
        Tcat := tv1.Items.AddChild(root, TScat[Icat]);
        TCat.StateIndex := 2;
        TSsub := TStringList(TScat.Objects[Icat]);
        FOR iSub := 0 TO TSsub.Count-1 DO
          begin
            IF TSsub[Isub] <> '' THEN
              begin
                Tsub := tv1.Items.AddChild(Tcat, TSsub[Isub]);
                TSub.StateIndex := 2;
              end
            ELSE
              Tsub := TCat;
            TSttl := TStringList(TSsub.Objects[Isub]);
            FOR Ittl := 0 TO TSttl.Count-1 DO
              begin
                Tttl := tv1.Items.AddChildObject(Tsub, TSttl[Ittl],
                  TSttl.Objects[Ittl]);
                Tttl.StateIndex := 1;
                IF Integer(TSttl.Objects[Ittl]) = HeldID THEN
                  tv1.Selected := Tttl;
              end;
          end;
      end;
    root.Expand(false);
  finally
    HeldID := -1;
    FOR Icat := TSCat.Count-1 DOWNTO 0 DO
      begin
        TSsub := TStringList(TScat.Objects[iCat]);
        FOR ISub := TSsub.Count-1 DOWNTO 0 DO
          begin
            TSttl := TStringList(TSsub.Objects[iSub]);
            TSttl.Free;
          end;
        TSsub.Free;  
      end;
    TScat.Free;
  end;
  dbCtrlGrid1.Visible := True;
end;

procedure TMakeForm.FormActivate(Sender: TObject);
begin
  IF First THEN
    begin
      dm1.cdsTwks.AfterPost := cdsTipsAfterThing;
      dm1.cdsTwks.AfterDelete := cdsTipsAfterThing;
      dm1.cdsData.BeforeInsert := cdsDataBeforeInsert;
      dm1.cdsData.AfterInsert := cdsDataAfterInsert;
      dm1.cdsTwks.BeforeInsert := cdsTipsBeforeInsert;
      dm1.cdsTwks.AfterInsert := cdsTipsAfterInsert;
      dm1.cdsTwks.ReadOnly := False;
      dm1.cdsData.ReadOnly := False;
      LoadTree;
      dbCtrlGrid1.Visible := True;
      First := False;
    end;
end;

procedure TMakeForm.FormCreate(Sender: TObject);
begin
  First := True;
  ininame := ExtractFileDir(Application.Exename)+'\RegistryRobot.Ini';
  WITH TIniFile.Create(ininame) DO
  try
    HeldID := ReadInteger('Settings', 'LastTip', -1);
  finally
    Free;
  end;
end;



procedure TMakeForm.tv1Change(Sender: TObject; Node: TTreeNode);
begin
  IF Node = nil THEN Exit;
  IF Node.Data = nil THEN Exit;
  dm1.cdsTwks.SetKey;
  dm1.cdsTwks.FieldByName('TwkID').AsInteger := Integer(Node.Data);
  IF NOT dm1.cdsTwks.GoToKey THEN Exit;
end;

procedure TMakeForm.DBEdit7ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  WITH TFormPlat.Create(Self) DO
  try
    dm1.cdsData.Edit;
    SetData((Sender AS TDBEdit).Text,
      (Sender AS TDBEdit).ClientToScreen(MousePos));
    IF ShowModal = mrOK THEN
      (Sender AS TDBEdit).Text := GetData;
  finally
    Free;
  end;
end;

procedure TMakeForm.cdsTipsAfterThing(DataSet: TDataSet);
begin
  HeldID := dm1.cdsTwks.FieldByName('TwkID').AsInteger;
  LoadTree;
end;

procedure TMakeForm.cdsTipsBeforeInsert(DataSet: TDataSet);
begin
  WITH OT DO
    IF DataSet.Eof THEN // unlikely
      begin
        Category    := '';
        SubCat      := '';
        Title       := '';
        Description := '';
      end
    ELSE
      begin
        Category    := DataSet.FieldByName('Category').Text;
        SubCat      := DataSet.FieldByName('SubCat').Text;
        Title       := 'COPY OF ' + DataSet.FieldByName('Title').Text;
        Description := DataSet.FieldByName('Description').Text;
      end;
end;

procedure TMakeForm.cdsDataBeforeInsert(DataSet: TDataSet);
begin
  IF dm1.cdsTwks.State = dsInsert THEN
    dm1.cdsTwks.Post;
  WITH OD DO
    IF DataSet.Eof THEN
      begin
        TwkID      := -1;
        Root       := '';
        Key        := '';
        Value      := '';
        DataType   := -1;
        ChangeType := -1;
        Special    := '';
        Data       := '';
        VerMask    := -1;
      end
    ELSE
      begin
        TwkID      := DataSet.FieldByName('TwkID').AsInteger;
        Root       := DataSet.FieldByName('Root').Text;
        Key        := DataSet.FieldByName('Key').Text;
        Value      := DataSet.FieldByName('Value').Text;
        DataType   := DataSet.FieldByName('DataType').AsInteger;
        ChangeType := DataSet.FieldByName('ChangeType').AsInteger;
        Special    := DataSet.FieldByName('Special').Text;
        Data       := DataSet.FieldByName('Data').Text;
        VerMask    := DataSet.FieldByName('VerMask').AsInteger;
      end;
end;

procedure TMakeForm.cdsDataAfterInsert(DataSet: TDataSet);
begin
  WITH OD DO
    IF TwkID >= 0 THEN
      begin
        DataSet.FieldByName('TwkID').AsInteger := TwkID;
        DataSet.FieldByName('Root').Text      := Root;
        DataSet.FieldByName('Key').Text      := Key;
        DataSet.FieldByName('Value').Text      := Value;
        DataSet.FieldByName('DataType').AsInteger := DataType;
        DataSet.FieldByName('ChangeType').AsInteger := ChangeType;
        DataSet.FieldByName('Special').Text      := Special;
        DataSet.FieldByName('Data').Text      := Data;
        DataSet.FieldByName('VerMask').AsInteger := VerMask;
      end
    ELSE
      begin
        DataSet.FieldByName('TwkID').AsInteger      :=
          dm1.cdsTwks.FieldByName('TwkID').AsInteger;
        DataSet.FieldByName('Root').Text            := 'HKCU';
        DataSet.FieldByName('Key').Text             := '';
        DataSet.FieldByName('Value').Text           := '';
        DataSet.FieldByName('DataType').AsInteger   := 1;
        DataSet.FieldByName('ChangeType').AsInteger := 1;
        DataSet.FieldByName('Special').Text         := '';
        DataSet.FieldByName('Data').Text            := '';
        DataSet.FieldByName('VerMask').AsInteger    := 63;
      end;
end;


procedure TMakeForm.DWORD41Click(Sender: TObject);
begin
  DBComboBox2.ItemIndex :=
    (Sender AS TMenuItem).Tag;
end;

procedure TMakeForm.Viewvalue41Click(Sender: TObject);
begin
  dbComboBox3.ItemIndex :=
    (Sender AS TMenuItem).Tag;
end;

procedure TMakeForm.cdsTipsAfterInsert(DataSet: TDataSet);
begin
  WITH OT DO
    begin
      DataSet.FieldByName('Category').Text    := Category;
      DataSet.FieldByName('SubCat').Text      := SubCat;
      DataSet.FieldByName('Title').Text       := Title;
      DataSet.FieldByName('Description').Text := Description;
    end;
end;

procedure TMakeForm.PopupMenu2Popup(Sender: TObject);
begin
  dm1.cdsData.Edit;
end;

procedure TMakeForm.FormDestroy(Sender: TObject);
begin
  WITH TIniFile.Create(ininame) DO
  try
    IF (tv1.Selected <> nil) AND (tv1.Selected.Data <> nil) THEN
      WriteInteger('Settings', 'LastTip', Integer(tv1.Selected.Data))
  finally
    Free;
  end;
end;

end.



