program RegistryRobot;

// Copyright  2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

{$R 'moreres.res' 'moreres.rc'}

uses
  Forms,
  Windows,
  SysUtils,
  mainu in 'mainu.pas' {MainForm},
  datau in 'datau.pas' {dm1: TDataModule},
  allfuncs in 'AllFuncs.pas',
  formposu in 'formposu.pas',
  AboutBox in 'Aboutbox.pas' {AboutForm},
  rrfuncs in 'rrfuncs.pas',
  superreg2 in 'superreg2.pas',
  annou in 'annou.pas' {NoteForm},
  Variants in 'Variants.pas',
  Registry in 'Registry.pas';

{$R *.res}
TYPE
  THandles = Record
    AppHandle : HWnd;
    WinHandle : HWnd;
  end;
VAR
  hMap : THandle;
  PH   : ^THandles;
const MainMapName = 'PC Magazine RegistryRobot Shared '+
  '{2B7B1F5F-C30F-488F-AA0B-DCFA1FCAF5E2}';

procedure CheckFiles;
VAR S : String;
begin
  S := ExtractFileDir(ParamStr(0));
  IF NOT FileExists(S + '\twks.xml') THEN
    IF NOT FileExists(S + '\Data.xml') THEN
      S := 'twks.xml and data.xml databases are'
    ELSE S := 'twks.xml database is'
  ELSE
    IF NOT FileExists(S + '\Data.xml') THEN
      S := 'data.xml database is'
    ELSE S := '';
  IF S <> '' THEN
    begin
      MessageBox(0, PChar(Format('RegistryRobot''s essential %s '+
        'not present in the program''s folder (%s).'#13#10#13#10+
        'Without the database files, it is impossible for '+
        'RegistryRobot to function. You will need to reinstall the '+
        'program.'#13#10#13#10'Click OK to terminate',
        [S, ExtractFileDir(ParamStr(0))])),
        'RegistryRobot', MB_OK OR MB_ICONSTOP);
      Halt;
    end;
end;

begin
  CHeckFiles;
  hMap := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MainMapName);
  IF hMap = 0 THEN // first instance
    begin
      hMap := CreateFileMapping($FFFFFFFF, NIL, PAGE_READWRITE, 0,
        SizeOf(THandles), MainMapName);
      PH := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);  Application.Initialize;
  Application.Title := 'RegistryRobot';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(Tdm1, dm1);
  Application.MainForm.HandleNeeded;
      PH^.AppHandle := Application.Handle;
      PH^.WinHandle := Application.Mainform.Handle;
      Application.Run;
    end
  ELSE
    begin
      PH := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      IF IsIconic(PH^.AppHandle) THEN
        ShowWindow(PH^.AppHandle, SW_RESTORE);
      SetForegroundWindow(PH^.WinHandle);
    end;
  UnMapViewOfFile(PH);
  CloseHandle(hMap);
end.
