unit annou;

// Copyright  2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus, StdActns, ActnList;

type
  TNoteForm = class(TForm)
    ActionList1      : TActionList;
      EditUndo1      : TEditUndo;
      EditCut1       : TEditCut;
      EditCopy1      : TEditCopy;
      EditPaste1     : TEditPaste;
      EditDelete1    : TEditDelete;
      EditSelectAll1 : TEditSelectAll;
    stWhat           : TStaticText;
    meAnno           : TMemo;
    pnlButtons       : TPanel;
      btnOK          : TButton;
      btnCancel      : TButton;
    pmAnno           : TPopupMenu;
      popUndo        : TMenuItem;
      popCut         : TMenuItem;
      popCopy        : TMenuItem;
      popPaste       : TMenuItem;
      popDelete      : TMenuItem;
      popSelect      : TMenuItem;
    N1               : TMenuItem;
    N2               : TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NoteForm: TNoteForm;

implementation

uses formposu;

{$R *.dfm}

procedure TNoteForm.FormCreate(Sender: TObject);
begin
  GetPosFmExeName(Application.Exename, Self, True);
end;

procedure TNoteForm.FormDestroy(Sender: TObject);
begin
  SetPosToExeName(Application.Exename, Self, True);
end;

procedure TNoteForm.FormResize(Sender: TObject);
// If the form gets too narrow for the title, make the title higher
// so the text can wrap
VAR R : TRect;
begin
  FillChar(R, SizeOf(R), 0);
  R.Right     := stWhat.Width;
  Canvas.Font := stWhat.Font;
  DrawText(Canvas.Handle, PChar(stWhat.Caption), -1,
    R, DT_CALCRECT OR DT_WORDBREAK);
  stWhat.Height := R.Bottom + 2;
end;

procedure TNoteForm.FormKeyPress(Sender: TObject; var Key: Char);
// The memo "eats" escape keystrokes, so we do this to make Esc work
begin
  IF Key = #27 THEN ModalResult := mrCancel;
end;

end.
