unit mainu;

// Copyright  2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

//DATE: Article April 22
//DATE: Final code April 30

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus, ActnList,
  AppEvnts, ToolWin, ImgList, StdActns, commctrl;

type
  TMainForm = class(TForm)
    ActionList1         : TActionList;
      // File actions
        acExit          : TAction;
      // Edit actions
        EditCopy1       : TEditCopy;
        EditSelectAll1  : TEditSelectAll;
      // Find actions
        acFind          : TAction;
        acFindNext      : TAction;
        acFindUndo      : TAction;
      // Tree actions
        acExAll         : TAction;
        acColAll        : TAction;
        acExOne         : TAction;
        acColOne        : TAction;
    acNextTweak: TAction;
    acPrevTweak: TAction;
        acTop           : TAction;
        acBottom        : TAction;
      // Tweak actions
        acApply         : TAction;
        acUndo          : TAction;
        acNote          : TAction;
        acDelUndo       : TAction;
        acHide          : TAction;
        acReveal        : TAction;
      // Help actions
        acHelp          : TAction;
        acAbout         : TAction;
    tbMenu              : TToolBar; // the toolbar menu
    MainMenu1           : TMainMenu;
      topFile           : TMenuItem;
        mnuExit         : TMenuItem;
      topEdit           : TMenuItem;
        mnuCopy         : TMenuItem;
        mnuSelAll       : TMenuItem;
      topFind           : TMenuItem;
        mnuFind         : TMenuItem;
        mnuFindNext     : TMenuItem;
        mnuFindUndo     : TMenuItem;
      topTree           : TMenuItem;
        mnuExAll        : TMenuItem;
        mnuColAll       : TMenuItem;
        mnuExOne        : TMenuItem;
        mnuColOne       : TMenuItem;
        mnuNextTip      : TMenuItem;
        mnuPrevTip      : TMenuItem;
      topTweak          : TMenuItem;
        mnuApply        : TMenuItem;
        mnuUndo         : TMenuItem;
        mnuNote         : TMenuItem;
        mnuHide         : TMenuItem;
        mnuReveal       : TMenuItem;
        mnuDelUndo      : TMenuItem;
      topHelp           : TMenuItem;
        mnuHelp         : TMenuItem;
        mnuAbout        : TMenuItem;
    tbMain              : TToolBar;
      tbFind            : TToolButton;
      tbFindNext        : TToolButton;
      tbExAll           : TToolButton;
      tbColAll          : TToolButton;
      tbExOne           : TToolButton;
      tbColOne          : TToolButton;
      tbNextTip         : TToolButton;
      tbPrevTip         : TToolButton;
      tbHelp            : TToolButton;
    PopupMenu1          : TPopupMenu;
      popCopy           : TMenuItem;
      popSelAll         : TMenuItem;
    gbTweaks            : TGroupBox;
      tv1               : TTreeView;
    vSplit              : TSplitter;
    pnlDesc             : TPanel;
      gbDesc            : TGroupBox;
        reDesc          : TRichEdit;
      hSplitDD          : TSplitter;
    pnlDetCon           : TPanel;
      gbDetail          : TGroupBox;
        reDetail        : TRichEdit;
      hsplitCd          : TSplitter;
      gbCtrls           : TGroupBox;
        sbCtrls         : TScrollBox;
        bvBtns          : TBevel;
        pnlAct          : TPanel;
          btnApply      : TButton;
          btnUndo       : TButton;
          Button1       : TButton;
    stBevel             : TStaticText; // sets off statusbar in XP
    sbMain              : TStatusBar;
    OpenDialog1         : TOpenDialog;
    FindDialog1         : TFindDialog;
    ApplicationEvents1  : TApplicationEvents;
    reHiddenForFind     : TRichEdit;
    ilHot               : TImageList;
    ilDim               : TImageList;
    iltv                : TImageList;
    N1                  : TMenuItem;
    N2                  : TMenuItem;
    N3                  : TMenuItem;
    N4                  : TMenuItem;
    N5                  : TMenuItem;
    tbSep1              : TToolButton;
    tbSep2              : TToolButton;
    tbSep3              : TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure acApplyUpdate(Sender: TObject);
    procedure acFindNextUpdate(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure acFindExecute(Sender: TObject);
    procedure acFindNextExecute(Sender: TObject);
    procedure acFindUndoExecute(Sender: TObject);
    procedure acExAllExecute(Sender: TObject);
    procedure acColAllExecute(Sender: TObject);
    procedure acExOneExecute(Sender: TObject);
    procedure acColOneExecute(Sender: TObject);
    procedure acNextTweakExecute(Sender: TObject);
    procedure acPrevTweakExecute(Sender: TObject);
    procedure acTopExecute(Sender: TObject);
    procedure acBottomExecute(Sender: TObject);
    procedure acApplyExecute(Sender: TObject);
    procedure acUndoExecute(Sender: TObject);
    procedure acNoteExecute(Sender: TObject);
    procedure acDelUndoExecute(Sender: TObject);
    procedure acHideExecute(Sender: TObject);
    procedure acRevealExecute(Sender: TObject);
    procedure acHelpExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure tv1Change(Sender: TObject; Node: TTreeNode);
    procedure tv1Collapsed(Sender: TObject; Node: TTreeNode);
    procedure tv1Expanded(Sender: TObject; Node: TTreeNode);
    procedure tv1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure vSplitCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure vSplitMoved(Sender: TObject);
    procedure vSplitPaint(Sender: TObject);
    procedure reDescResizeRequest(Sender: TObject; Rect: TRect);
    procedure reDetailResizeRequest(Sender: TObject; Rect: TRect);
    procedure hSplitDDCanResize(Sender: TObject;
      var NewSize: Integer; var Accept: Boolean);
    procedure hSplitDDMoved(Sender: TObject);
    procedure hSplitPaint(Sender: TObject);
    procedure hsplitCdCanResize(Sender: TObject;
      var NewSize: Integer; var Accept: Boolean);
    procedure hsplitCdMoved(Sender: TObject);
    procedure pnlActMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure FindDialog1Close(Sender: TObject);
    procedure AlphaKeyPress(Sender: TObject; var Key: Char);
    procedure btnFileClick(Sender: TObject);
    procedure btnIconClick(Sender: TObject);
    procedure btnFolderClick(Sender: TObject);
    procedure eBlankChange(Sender: TObject);
  private
    { Private declarations }
    ConNeeds    : Integer; // needed height for controls
    CurVerMask  : Word;    // current version mask
    CurVerStr   : String;  // ... and as a string
    DesDelta    : Integer; // desc height vs. its container
    DesNeeds    : Integer; // needed height for description
    DetDelta    : Integer; // detail height vs. its container
    DetNeeds    : Integer; // needed height for detail
    filfols     : ARRAY[0..9] OF String; // file/folder names
    filters     : ARRAY[0..9] OF String; // file filters
    FindPos     : TPoint;  // position of Find dialog
    FindWhat    : String;  // string to find
    FirstTime   : Boolean; // true for first OnActivate
    heldID      : Integer; // holds ID during tree reload
    ininame     : String;  // name for INI  file
    IsUndo      : Boolean; // True if current tweak is an Undo
    PrivMaskCur : Integer; // current privilege mask
    PrivMaskTwk : Integer; // tweak's privilege mask
    ViewOnly    : Boolean; // true if viewing all platforms
    procedure AddDescription(re : TRichEdit; vTwkID : Integer);
    procedure AddNote(re : TRichEdit);
    procedure AddPlatform(vMask : Word; re : TRichEdit);
    procedure ApplyCurrent;
    procedure ClearFilFols;
    procedure DoSpecial(const Spec, Data, fRoot, fKey,
      fValue : String; VAR NextY, Ctrls : Integer);
    procedure FillDetail;
    function  GetCurrentData(vRoot, vKey, vVal, vDef : String;
      bin : Boolean) : String;
    function  GetUserData(typ : Char; VAR NumSpec : Integer) : String;
    procedure LoadTree;
    procedure ShareVertical;
    function  ToNextTweak(TN : TTreeNode) : TTreeNode;
    function  ToPrevTweak(TN : TTreeNode) : TTreeNode;
    procedure UndoCurrent;
    function  VarFromReg(const S : String) : String;
    procedure WMGETMinMaxInfo(VAR Msg: TWMGetMinMaxInfo);
      message WM_GETMINMAXINFO;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses datau, AboutBox, strUtils, rrfuncs, allfuncs, Registry,
  SuperReg2, formposu, dbClient, inifiles, richedit, annou;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
  procedure GetMBFont;
  // Get and use the current message box font, but constrain it
  // from 8 to 12 points
  VAR NCM : NONCLIENTMETRICS;
  begin
    SetLastError(0);
    FillChar(NCM, SizeOf(NCM), 0);
    NCM.cbSize := SizeOf(NCM);
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS, SizeOf(NCM), @NCM,
      0);
    Self.Font.Handle := CreateFontIndirect(NCM.lfMessageFont);
    IF Self.Font.Size < 8 THEN Self.Font.Size  := 8;
    IF Self.Font.Size > 12 THEN Self.Font.Size := 12;
  end;

  procedure SetREFont;
  // Set the description RichEdit to use the current font
  begin
    reDesc.DefAttributes.Name    := Self.Font.Name;
    reDesc.DefAttributes.Size    := Self.Font.Size;
    reDesc.SelAttributes.Name    := Self.Font.Name;
    reDesc.SelAttributes.Size    := Self.Font.Size;
    reDesc.Paragraph.RightIndent := 8;
    reDesc.Paragraph.FirstIndent := 8;
  end;

begin
  ViewOnly := FindCmdLineSwitch('viewonly');
  IF ViewOnly THEN Self.Caption := 'RegistryRobot (view only)';
  PrivMaskCur := GetPrivMask;
  GetMBFont;
  SetREFont;
  // Load resource images for ImageLists. We do it this way so there
  // will be no compatibility problems with earlier versions of the
  // common controls.
  LoadImageList(ilTV,   2,  6);
  LoadImageList(ilHot,  7, 21);
  LoadImageList(ilDim, 22, 31);
  ininame := ChangeFileExt(Application.Exename, '.INI');
  GetPosFmIni(ininame, Self, True);
  WITH TIniFile.Create(ininame) DO
  try
    HeldID := ReadInteger('Settings', 'LastTip', -1);
    gbTweaks.Width := ReadInteger('Settings', 'Split1', 250);
    FindPos.X := ReadInteger('Settings', 'FindX', 10);
    FindPos.Y := ReadInteger('Settings', 'FindY', 10);
    FindWhat := ReadString('Settings', 'FindWhat', '');
  finally
    free;
  end;
  FirstTime  := True;
  CurVerMask := GetVerMask(CurVerStr);
  {$IFDEF DebugOnly}
  IF NOT ViewOnly THEN
    begin
      IF FindCmdLineSwitch('danger') THEN
        begin
          Self.Caption := 'RegistryRobot (Danger: all IE and all same-family tweaks active)';
          CurVerMask := CurVerMask OR cI4p;
          IF CurVerMask AND c9x > 0 THEN
            CurVerMask := CurVerMask OR c9x
          ELSE CurVerMask := CurVerMask OR cNTx;
        end
      ELSE IF FindCmdLineSwitch('peril') THEN
        begin
          Self.Caption := 'RegistryRobot (Peril: ALL tweaks active)';
          CurVerMask := CurVerMask OR cI4p OR c9x OR cNTx;
        end;
    end;
  {$ENDIF}
  ClearFilFols;
  Application.HelpFile := ChangeFileExt(Application.Exename, '.HLP');
  // Some shortcut keys can't be set at design time
  acExAll.ShortCut     := Shortcut(VK_MULTIPLY, [ssShift]);
  acColAll.Shortcut    := Shortcut(VK_SUBTRACT, [ssShift]);
  acExOne.Shortcut     := Shortcut(VK_ADD, []);
  acColOne.Shortcut    := Shortcut(VK_SUBTRACT, []);
  // Calculate the size difference between each RichEdit and its
  // container - we use these later in resizing
  DesDelta := gbDesc.Height - reDesc.Height;
  DetDelta := gbDetail.Height - reDetail.Height;
end;

procedure TMainForm.FormActivate(Sender: TObject);
const fil : ARRAY[1..2] OF String = ('Twks', 'Data');
begin
  // IF there was a problem loading the tips or data databases, we
  //   respond HERE rather than in the data module, because HERE
  //   we have access to Application.Terminate
  CASE dm1.Status OF
    1, 2: begin
      MessageBox(Self.Handle, PChar(Format('RegistryRobot''s '+
        'essential database file %s.xml is present in the '+
        'program''s folder, but it is corrupted.'#13#10#13#10+
        'Without this database file, it is impossible for '+
        'RegistryRobot to function. You will need to reinstall '+
        'the program.'#13#10#13#10'Click OK to terminate.',
        [fil[dm1.Status]])), 'RegistryRobot', MB_OK OR MB_ICONSTOP);
      Application.Terminate;
    end;
    3: begin
      MessageBox(Self.Handle, 'RegistryRobot relies on the support '+
        'file MIDAS.DLL for database handling. This file is '+
        'apparently absent from your Windows System folder. Please '+
        'reinstall RegistryRobot.', 'RegistryRobot', MB_OK OR
        MB_ICONSTOP);
      Application.Terminate;
    end;
  END;
  IF FirstTime THEN
    begin
      LoadTree;
      FirstTime := False;
      WITH TIniFile.Create(ininame) DO
      try
        IF ReadBool('Settings', 'VeryFirst', True) THEN
          MessageBox(Self.Handle, 'Please bear in mind that many '+
            'of RegistryRobot''s tweaks do not take effect '+
            'immediately. Some require you to log off and on '+
            'again, while others may require a full Windows '+
            'restart. If you apply a tweak and it seems to have '+
            'had no effect, first try logging off, then try a full '+
            'restart.'#13#10#13#10'This notification will not be '+
            'repeated.', 'RegistryRobot', MB_OK OR
            MB_ICONINFORMATION);
        WriteBool('Settings', 'VeryFirst', False);
      finally
        Free;
      end;
    end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SetPosToIni(ininame, Self, True);
  WITH TIniFile.Create(ininame) DO
  try
    IF (tv1.Selected <> nil) AND (tv1.Selected.Data <> nil) THEN
      WriteInteger('Settings', 'LastTip', Integer(tv1.Selected.Data))
    ELSE
      WriteInteger('Settings', 'LastTip', -1);
    WriteInteger('Settings', 'FindX', FindPos.X);
    WriteInteger('Settings', 'FindY', FindPos.Y);
    WriteString('Settings', 'FindWhat', FindWhat);
    WriteInteger('Settings', 'Split1', gbTweaks.Width);
  finally
    free;
  end;
end;

procedure TMainForm.FormResize(Sender: TObject);
// When the form resizes, we need to "remind" the two RichEdits
// to refresh themselves. This in turn triggers their OnResizeRequest
// event handlers
begin
  reDesc.Refresh;
  reDetail.Refresh;
  ShareVertical;
end;

procedure TMainForm.acApplyUpdate(Sender: TObject);
VAR
  N         : Integer;
  AppEnable : Boolean;
begin
  // acReveal is always enabled
  // IF no tip is selected the other five are disabled
  IF (tv1.Selected = nil) OR (tv1.Selected.Data = nil) OR ViewOnly THEN
    begin
      acApply.Enabled   := False;
      acUndo.Enabled    := False;
      acNote.Enabled    := False;
      acDelUndo.Enabled := False;
      acHide.Enabled    := False;
    end
  ELSE
  // If a tip is selected, Hide and Note are enabled
    begin
      acHide.Enabled := True;
      acNote.Enabled := True;
      // If it's a Undo type, then Undo and DelUndo are enabled,
      // and Apply is disabled
      IF IsUndo THEN
        begin
          acUndo.Enabled    := True;
          acDelUndo.Enabled := True;
          acApply.Enabled   := False;
        end
      ELSE
      // If it's a "DO", Undo and DelUndo are disabled, and
      // DO IT is unless it's a view-only. Note that if some
      // user data is absent, acApply's tag gets set to 1,
      // causing acApplyExecute to point out the need for that
      // data rather than actually applying the tweak.
        begin
          acUndo.Enabled    := False;
          acDelUndo.Enabled := False;
          acApply.Tag       := 0;
          AppEnable         := True;
          WITH sbCtrls DO
            FOR N := ControlCount-1 DOWNTO 0 DO
              CASE Controls[N].Tag OF
                1 : begin
                  acApply.Tag := 1;
                  Break;
                end;
                2 : begin
                  AppEnable := False;
                  Break;
                end;
              END;
          acApply.Enabled := AppEnable;
        end;
    end;
  btnApply.Enabled := acApply.Enabled;
  btnUndo.Enabled := acUndo.Enabled;
end;

procedure TMainForm.acFindNextUpdate(Sender: TObject);
begin
  acFindNext.Enabled := (FindWhat <> '') AND (Self.Enabled);
end;

procedure TMainForm.acExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.acFindExecute(Sender: TObject);
begin
  WITH FindDialog1 DO
    begin
      Position := FindPos;
      FindText := FindWhat;
      Execute;
    end;
end;

procedure TMainForm.acFindNextExecute(Sender: TObject);
VAR
  IsDown  : Boolean;
  sType   : TSearchTypes;
  Start   : Integer;
  Test    : Integer;
  TwkID   : Integer;
  Where   : Integer;
begin
  WITH FindDialog1 DO
    begin
      IsDown := frDown IN FindDialog1.Options;
      sType  := [];
      IF frMatchCase IN Options THEN sType := sType + [stMatchCase];
      IF frWholeWord IN Options THEN sType := sType + [stWholeWord];
    end;
  // IF no tip selected, start at top if down, bottom if up
  IF tv1.Selected = nil THEN
    begin
      IF IsDown THEN Start := 0
      ELSE           Start := tv1.Items.Count;
    end
  ELSE Start := tv1.Selected.AbsoluteIndex;
  Test    := Start;
  Where   := -1;
  REPEAT
    IF IsDown THEN
      begin
        // Move to the next actual tip
        Inc(Test);
        WHILE (Test < tv1.Items.Count) AND
          (tv1.Items[Test].Data = nil) DO
            Inc(Test);
        IF Test >= tv1.Items.Count THEN
          begin
            MessageBox(Handle, PChar(Format('"%s" not found.',
              [FindWhat])), 'RegistryRobot', MB_OK OR
              MB_ICONINFORMATION);
            Break;
          end;
      end
    ELSE
      begin
        // Move to the previous actual tip
        Dec(Test);
        WHILE (Test > 0) AND (tv1.Items[Test].Data = nil) DO
          Dec(Test);
        IF Test <= 0 THEN
          begin
            MessageBox(Handle, PChar(Format('"%s" not found.',
              [FindWhat])), 'RegistryRobot', MB_OK OR
              MB_ICONINFORMATION);
            Break;
          end;
      end;
    TwkID := Integer(tv1.Items[Test].Data);
    WITH dm1.cdsTwks DO
      begin
        SetKey;
        FieldByName('TwkID').AsInteger := TwkID;
        IF GotoKey THEN
          begin
            // Build hidden replica of Description for tweak
            AddDescription(reHiddenForFind, TwkID);
            AddNote(reHiddenForFind);
            // Search the replica
            Where := reHiddenForFind.FindText(FindWhat,0,
              reHiddenForFind.GetTextLen, sType);
            IF Where <> -1 THEN
              Break;
          end;
      end;
  UNTIL False;
  IF Where <> -1 THEN
    begin
      tv1.Selected := tv1.Items[Test];
      WITH reDesc DO
        begin
          SelStart := where;
          SelLength := Length(FindWhat);
        end;
    end;
end;

procedure TMainForm.acFindUndoExecute(Sender: TObject);
VAR
  Test  : Integer;
  FoundIt : Boolean;
begin
  IF tv1.Selected = nil THEN
    Test := 0
  ELSE
    Test := tv1.Selected.AbsoluteIndex;
  FoundIt := False;
  REPEAT
    Inc(Test);
    IF Test >= tv1.Items.Count THEN
      Break;
    IF tv1.Items[Test].Data = nil THEN Continue;
    dm1.cdsTwks.SetKey;
    dm1.cdsTwks.FieldByName('TwkID').AsInteger :=
      Integer(tv1.Items[Test].Data);
    IF NOT dm1.cdsTwks.GotoKey THEN Continue;
    IF NOT dm1.cdsUndo.EoF THEN
      begin
        FoundIt := True;
        Break;
      end;
  UNTIL False;
  IF FoundIt THEN
    tv1.Selected := tv1.Items[Test]
  ELSE
    MessageBox(Handle, 'There are no more tweaks that have Undo '+
      'data stored.', 'RegistryRobot', MB_OK OR MB_ICONINFORMATION);
end;

procedure TMainForm.acExAllExecute(Sender: TObject);
begin
  tv1.Items[0].Expand(True);
end;

procedure TMainForm.acColAllExecute(Sender: TObject);
// Collapse All means collapse all down to the first level of
// child nodes (the categories)
VAR TN : TTreeNode;
begin
  TN := tv1.Selected;
  IF (TN <> nil) AND (TN.Parent <> nil) THEN
    WHILE TN.Parent.Parent <> NIL DO
      TN := TN.Parent;
  LockWindowUpdate(tv1.Handle);
  try
    tv1.Items[0].Collapse(True);
    tv1.Items[0].Expand(False);
    IF TN <> nil THEN
      tv1.Selected := TN;
  finally
    LockWindowUpdate(0);
  end;
end;

procedure TMainForm.acExOneExecute(Sender: TObject);
// Expand category - climb the tree to the category for the
// selected item (the node just below root) and expand it
VAR Cat : TTreeNode;
begin
  IF tv1.Selected <> nil THEN
    begin
      Cat := tv1.Selected;
      WHILE Cat.Level > 1 DO Cat := Cat.Parent;
      Cat.Expand(True);
    end;
end;

procedure TMainForm.acColOneExecute(Sender: TObject);
// Collapse one - if it's the root, collapse down to just showing
// categories. Otherwise, climb the tree to the current node's
// category and collapse THAT.
VAR Cat : TTreeNode;
begin
  IF tv1.Selected <> nil THEN
    begin
      IF tv1.Selected.Parent = nil THEN
        acColAllExecute(acColAll)
      ELSE
        begin
          Cat := tv1.Selected;
          WHILE Cat.Level>1 DO Cat := Cat.Parent;
          Cat.Collapse(True);
        end;
    end;
end;

procedure TMainForm.acNextTweakExecute(Sender: TObject);
// Move to the next tweak, if there is one
VAR TN : TTreeNode;
begin
  TN := ToNextTweak(tv1.Selected);
  IF TN <> nil THEN tv1.Selected := TN;
end;

procedure TMainForm.acPrevTweakExecute(Sender: TObject);
// Move to the previous tweak, if there is one
VAR TN : TTreeNode;
begin
  TN := ToPrevTweak(tv1.Selected);
  IF TN <> nil THEN tv1.Selected := TN;
end;

procedure TMainForm.acTopExecute(Sender: TObject);
// Move to the first tweak
begin
  tv1.Selected := nil;
  acNextTweakExecute(acNextTweak);
end;

procedure TMainForm.acBottomExecute(Sender: TObject);
// Move to the last tweak
begin
  tv1.Selected := tv1.Items[tv1.Items.Count-1];
end;

procedure TMainForm.acApplyExecute(Sender: TObject);
begin
  WITH Sender AS TAction DO
    IF Tag = 0 THEN
      ApplyCurrent
    ELSE
      MessageBox(Handle, 'RegistryRobot needs you to supply some '+
        'data before it can make the changes specified by this '+
        'tweak. Please check the Controls pane.',
        'RegistryRobot', MB_OK OR MB_ICONINFORMATION);
end;

procedure TMainForm.acUndoExecute(Sender: TObject);
begin
  UndoCurrent
end;

procedure TMainForm.acNoteExecute(Sender: TObject);
VAR
  TwkID : Integer;
  TN    : TTreeNode;
  S     : String;

  function GetTweakMask: Word;
  begin
    Result := 0;
    dm1.cdsData.First;
    WHILE NOT dm1.cdsData.Eof DO
      begin
        Result := Result OR
          dm1.cdsData.FieldByName('VerMask').AsInteger;
        dm1.cdsData.Next;
      end;
  end;


begin
  IF tv1.Selected = nil THEN Exit;
  IF tv1.Selected.Data = nil THEN Exit;
  TN    := tv1.Selected;
  TwkID := Integer(tv1.Selected.Data);
  dm1.cdsNote.First;
  WITH TNoteForm.Create(Self) DO
  try
    stWhat.Caption := TN.Text;
    // If there'sno existing note, start out blank
    IF dm1.cdsNote.Eof THEN
      meAnno.Text := ''
    ELSE
    // Otherwise, load the existing note and position the caret
    // at the end of it
      begin
        meAnno.Text     := dm1.cdsNote.FieldByName('Note').Text;
        meAnno.SelStart := meAnno.GetTextLen;
      end;
    IF ShowModal = mrOK THEN
      begin
        S := Trim(meAnno.Text);
        dm1.cdsNote.ReadOnly := False;
        // If there was no note, add one (if it's not blank)
        IF dm1.cdsNote.EoF THEN
          begin
            IF S <> '' THEN
              begin
                dm1.cdsNote.Append;
                dm1.cdsNote.FieldByName('TwkID').AsInteger := TwkID;
                dm1.cdsNote.FieldByName('Note').Text := S;
                dm1.cdsNote.Post;
              end;
          end
        // Otherwise, change the existing note (or delete if blank)
        ELSE
          begin
            IF S <> '' THEN
              begin
                dm1.cdsNote.Edit;
                dm1.cdsNote.FieldByName('Note').Text := S;
                dm1.cdsNote.Post;
              end
            ELSE dm1.cdsNote.Delete;
          end;
        dm1.cdsNote.ReadOnly := True;
      end;
  finally
    Free;
  end;
  AddDescription(reDesc, TwkID);
  AddNote(reDesc);
  AddPlatform(GetTweakMask, reDesc);
  ShareVertical;
end;

procedure TMainForm.acDelUndoExecute(Sender: TObject);
VAR
  addKeys : Integer;
  chgVals : Integer;
  delKeys : Integer;
  typ : Integer;
  Msg : String;
begin
  IF NOT acDelUndo.Enabled   THEN Exit;
  IF tv1.Selected = nil      THEN Exit;
  IF tv1.Selected.Data = nil THEN Exit;
  addKeys := 0;
  chgVals := 0;
  delKeys := 0;
  dm1.cdsUndo.First;
  Msg := '';
  WHILE NOT dm1.cdsUndo.EoF DO
    begin
      typ := dm1.cdsUndo.FieldByName('ChangeType').AsInteger;
      CASE typ OF
        0   : Inc(addKeys);
        1,3 : Inc(chgVals);
        2   : Inc(delKeys);
      end;
      dm1.cdsUndo.Next;
    end;
  IF AddKeys > 0 THEN
    begin
      MessageBox(Handle, 'This tweak involved the deletion of a '+
        'Registry key. If you were to delete the Undo information, '+
        'it would become impossible to restore that key and its '+
        'subkeys and values. RegistryRobot cannot permit this - it '+
        'is too dangerous.', 'RegistryRobot', MB_OK OR MB_ICONSTOP);
      Exit;
    end;
  IF (chgVals > 0) THEN
    begin
      IF delKeys > 0 THEN
        Msg := 'delete one or more keys this tweak added and '+
          'restore original data for one or more values this tweak '+
          'changed'
      ELSE
        Msg := 'restore original data for one or more values this '+
         'tweak changed';
    end
  ELSE
      IF delKeys > 0 THEN
        Msg := 'delete one or more keys this tweak added'
      ELSE
        Msg := 'restore settings this tweak changed'; // shouldn't happen
  IF MessageBox(Handle, PChar('If you delete Undo information for '+
    'this tweak, you will no longer be able to click Undo and '+Msg+
    '. Please review the Undo detail to be sure you wish to '+
    'proceed.'#13#10#13#10'Proceed anyway?'), 'RegistryRobot',
    MB_YESNO OR MB_ICONQUESTION) <> idYes THEN Exit;
  dm1.cdsUndo.ReadOnly := False;
  dm1.cdsUndo.First;
  WHILE NOT dm1.cdsUndo.EoF DO
    dm1.cdsUndo.Delete;
  dm1.cdsUndo.ReadOnly := True;
  tv1Change(tv1, tv1.Selected);
end;

procedure TMainForm.acHideExecute(Sender: TObject);
VAR TN : TTreeNode;
begin
  IF tv1.Selected = nil      THEN Exit;
  IF tv1.Selected.Data = nil THEN Exit;
  // Find the next tweak, so we can select it after hiding this one
  TN := ToNextTweak(tv1.Selected);
  // No next tweak? OK, take the previous wone
  IF TN = nil THEN
    TN := ToPrevTweak(tv1.Selected);
  IF TN <> nil THEN HeldID := Integer(TN.Data);
  dm1.cdsTwks.ReadOnly := False;
  dm1.cdsTwks.Edit;
  dm1.cdsTwks.FieldByName('Hide').AsBoolean := True;
  dm1.cdsTwks.Post;
  dm1.cdsTwks.ReadOnly := True;
  LoadTree;
end;

procedure TMainForm.acRevealExecute(Sender: TObject);
begin
  IF (tv1.Selected <> nil) AND (tv1.Selected.Data <> nil) THEN
    HeldID := Integer(tv1.Selected.Data);
  dm1.cdsTwks.ReadOnly := False;
  dm1.cdsTwks.First;
  WHILE NOT dm1.cdsTwks.EoF DO
    begin
      dm1.cdsTwks.Edit;
      dm1.cdsTwks.FieldByName('Hide').AsBoolean := False;
      dm1.cdsTwks.Post;
      dm1.cdsTwks.Next;
    end;
  dm1.cdsTwks.ReadOnly := True;
  LoadTree;
end;

procedure TMainForm.acHelpExecute(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TMainForm.acAboutExecute(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    SetVer(CurVerStr);
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.tv1Change(Sender: TObject; Node: TTreeNode);
VAR
  TwkID     : Integer;
  allMask   : Word;
  YHeight   : Integer;
  CtrlLines : Integer;

  procedure ClearControls;
  VAR N : Integer;
  begin
    WITH sbCtrls DO
      begin
        FOR N := ControlCount-1 DOWNTO 0 DO
          IF NOT Assigned(Controls[N].Action) THEN
            Controls[N].Free;
        AutoScroll := False;
      end;
    ClearFilFols;
    YHeight   := 8;
    CtrlLines := 0;
  end;

  function GoToTip(vTwkID : Integer) : Boolean;
  begin
    WITH dm1.cdsTwks DO
      begin
        SetKey;
        FieldByName('TwkID').AsInteger := vTwkID;
        Result := GoToKey;
      end;
  end;

  function CheckUndo : Boolean;
  begin
    WITH dm1.cdsUndo DO
      begin
        First;
        Result := (NOT EoF);
      end;
  end;

  function ControlsAndMask(VAR NextY : Integer) : Word;
  // Build a mask indicating which platforms have actions defined
  // in this tip. If it's not an "Undo", build any necessary
  // user-input controls.
  VAR
    rRoot, rKey, rValue  : String;
    special : String;
  begin
    PrivMaskTwk := 0;
    WITH dm1.cdsData DO
      begin
        Result := 0;
        First;
        WHILE NOT EoF DO
          begin
            IF (CurVerMask AND FieldByName('VerMask').AsInteger <> 0) OR
              ViewOnly THEN
              begin
                special := FieldByName('special').Text;
                rroot   := FieldByName('Root').Text;
                CASE RootFor(rRoot) OF
                  HKEY_CURRENT_USER   :
                    PrivMaskTwk := PrivMaskTwk OR pHKCU;
                  HKEY_CLASSES_ROOT   :
                    PrivMaskTwk := PrivMaskTwk OR pHKCR;
                  HKEY_CURRENT_CONFIG :
                    PrivMaskTwk := PrivMaskTwk OR pHKCC;
                  HKEY_LOCAL_MACHINE  :
                    PrivMaskTwk := PrivMaskTwk OR pHKLM;
                  HKEY_USERS          :
                    PrivMaskTwk := PrivMaskTwk OR pHKU;
                END;
                rkey    := FieldByName('Key').Text;
                rvalue  := FieldByName('Value').Text;
                IF (NOT IsUndo) AND (special <> '') THEN
                  DoSpecial(Special, FieldByName('Data').Text,
                    rRoot, rKey, rValue, NextY, CtrlLines);
              end;
            Result := Result OR FieldByName('VerMask').AsInteger;
            Next;
          end;
      end;
  end;

  procedure EnableDisable(Enable : Boolean);
  begin
    IF NOT Enable THEN
      begin
        reDesc.Clear;
        reDetail.Clear;
        reDesc.Color        := clBtnFace;
        reDetail.Color      := clBtnFace;
        gbDesc.Enabled      := False;
        gbDetail.Enabled    := False;
        hSplitDD.Enabled    := False;
        hSplitCD.Enabled    := False;
        gbDesc.Font.Color   := clGrayText;
        gbDetail.Font.Color := clGrayText;
        gbCtrls.Font.Color  := clGrayText;
      end
    ELSE
      begin
        gbDesc.Enabled      := True;
        gbDetail.Enabled    := True;
        hSplitDD.Enabled    := True;
        hSplitCD.Enabled    := True;
        gbDesc.Font.Color   := clWindowText;
        gbDetail.Font.Color := clWindowText;
        gbCtrls.Font.Color  := clWindowText;
        reDesc.Color        := clWindow;
        reDetail.Color      := clWindow;
        reDesc.Enabled      := True;
        reDetail.Enabled    := True;
      end;
  end;
begin
  IF Node = nil THEN Exit;
  ClearControls;
  IsUndo := False;
  EnableDisable(Node.Data <> nil);
  IF (Node.Data <> nil) THEN
    begin
      TwkID := Integer(Node.Data);
      IF NOT GoToTip(TwkID) THEN
        begin
          reDesc.Text := Format('Database error: The specified '+
            'tweak ID #T%.04d does not exist', [TwkID]);
          Exit;
        end;
      AddDescription(reDesc, TwkID);
      IsUndo  := CheckUndo;
      allMask := ControlsAndMask(YHeight);
      AddNote(reDesc);
      AddPlatform(allMask, reDesc);
      reDesc.SelStart := 0;
      FillDetail;
    end;
  // IF any controls were added, show the bevel that separates them
  // from the three static buttons
  bvBtns.Visible := sbCtrls.ControlCount > 0;
  conNeeds       := YHeight + 16 + pnlAct.Height;
  gbCtrls.Height := ConNeeds;
  // Store the minimum height for the Controls groupbox in its Tag
  IF bvBtns.Visible THEN
    begin
      conNeeds    := conNeeds  + GetSystemMetrics(SM_CXHSCROLL);
      gbCtrls.Tag := 50 + PnlAct.Height;
    end
  ELSE gbCtrls.Tag := 16 + PnlAct.Height;
  sbCtrls.AutoScroll := True;
  acApplyUpdate(acApply);
  ShareVertical;
end;

procedure TMainForm.tv1Collapsed(Sender: TObject; Node: TTreeNode);
VAR TN : TTreeNode;
begin
  // Never collapse all the way to the root. If the collapsed node
  // is the root, collapse all of its children and then expand it
  // by one level. Otherwise, set its icon to a closed folder.
  IF Node.Parent = nil THEN
    begin
      TN := Node.getFirstChild;
      WHILE TN <> nil DO
        begin
          TN.Collapse(True);
          TN := TN.getNextSibling;
        end;
      Node.Expand(False);
    end
  ELSE Node.StateIndex := 2;
end;

procedure TMainForm.tv1Expanded(Sender: TObject; Node: TTreeNode);
begin
  // Set the node's icon to an open folder
  Node.StateIndex := 3;
end;

procedure TMainForm.tv1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Select the node that's right-clicked
  IF Button <> mbRight THEN Exit;
  WITH Sender AS TTreeview DO
    Selected := GetNodeAt(X,Y);
end;

procedure TMainForm.vSplitCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  // Don't let the splitter make either the Tweaks group box or
  // the description panel too narrow
  IF NewSize < gbTweaks.Constraints.MinWidth THEN
    Accept := False
  ELSE IF NewSize + (Sender AS TSPlitter).Width +
    pnlDesc.Constraints.MinWidth > Self.ClientWidth THEN
      Accept := False;
end;

procedure TMainForm.vSplitMoved(Sender: TObject);
// After a vertical-split move, force the TRichEdits to recalculate
// their word-wrapping, then share out the vertical space again.
begin
  reDesc.Refresh;
  reDetail.Refresh;
  ShareVertical;
end;

procedure TMainForm.vSplitPaint(Sender: TObject);
// This routine paints a "ridge" in the middle of the vertical
// splitter that occupies the middle 1/2 of its height
VAR R : TRect;
begin
  WITH (Sender AS TSplitter), Canvas DO
    begin
      Pen.Color := clbtnHighlight;
      R := Rect(Width DIV 2, Height DIV 4, Width DIV 2,
        Height-(Height DIV 4));
      // PolyLine is a quick way to draw a line, and putting the
      // endpoints into a rectangle is convenient, too.
      PolyLine([R.TopLeft, R.BottomRight]);
      OffsetRect(R, 1, 1);
      Pen.Color := clBtnShadow;
      PolyLine([R.TopLeft, R.BottomRight]);
    end;

end;

procedure TMainForm.reDescResizeRequest(Sender: TObject;
  Rect: TRect);
// This event handler is called when the Description rich edit needs
// to recalculate its required height. The height (plus the height
// difference of the richedit and its enclosing TGroupBox) is stored
// in the DesNeeds variable. The minimum width is stored in the group
// box's Tag field.
begin
  DesNeeds := Rect.Bottom + DesDelta;
  IF DesNeeds < gbDesc.Tag THEN
    DesNeeds := gbDesc.Tag;
end;

procedure TMainForm.reDetailResizeRequest(Sender: TObject; Rect: TRect);
// See the comment for reDescResizeRequest
begin
  DetNeeds := Rect.Bottom + DetDelta;
  IF DetNeeds < gbDetail.Tag THEN
    DetNeeds := gbDetail.Tag;
end;

procedure TMainForm.hSplitDDCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
// Don't let the splitter make either the Description or the
// Details box too short
begin
  IF NewSize < gbDetail.Tag + gbCtrls.Tag THEN
    Accept := False
  ELSE IF gbDesc.Tag + NewSize > pnlDesc.Height THEN
    Accept := False;
end;

procedure TMainForm.hSplitDDMoved(Sender: TObject);
// When the Detail/Description splitter moves, we need to deal
// with the fact that Detail and Controls reside in a separate
// panel (pnlDetCon).
begin
  IF detneeds + conneeds < pnlDetCon.Height THEN
    begin
      IF gbDetail.Height < detneeds THEN
        gbDetail.Height := detneeds;
      IF gbCtrls.Height < conneeds THEN
        gbCtrls.Height := conneeds;
    end
  ELSE IF gbDetail.Height < gbDetail.Tag THEN
    gbCtrls.Height := pnlDetCon.Height - gbDetail.Tag
  ELSE IF gbCtrls.Height < gbCtrls.Tag THEN
    gbCtrls.Height := gbCtrls.Tag;
  reDesc.Refresh;
  reDetail.Refresh;
end;

procedure TMainForm.hSplitPaint(Sender: TObject);
// This routine paints a "ridge" in the middle of each horizontal
// splitter that occupies the middle 1/2 of its width
VAR R : TRect;
begin
  WITH (Sender AS TSplitter), Canvas DO
    begin
      Pen.Color := clbtnHighlight;
      R := Rect(Width DIV 4, Height DIV 2, Width-Succ((Width DIV 4)),
        Height DIV 2);
      PolyLine([R.TopLeft, R.BottomRight]);
      OffsetRect(R, 1, 1);
      Pen.Color := clBtnShadow;
      PolyLine([R.TopLeft, R.BottomRight]);
    end;
end;

procedure TMainForm.hsplitCdCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
// Don't let the splitter make either the Controls or the
// Details box too short
begin
  IF NewSize < gbCtrls.Tag THEN
    Accept := False
  ELSE IF NewSize > conNeeds THEN
    Accept := False
  ELSE IF NewSize > pnlDetCon.Height - gbDetail.Tag THEN
    Accept := False;
end;

procedure TMainForm.hsplitCdMoved(Sender: TObject);
// After a split move, force the TRichEdits to recalculate
// their word-wrapping.
begin
  reDesc.Refresh;
  reDetail.Refresh;
end;

procedure TMainForm.pnlActMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This enables flyover hints for disabled buttons
VAR
  P : TPoint;
  N : Integer;
begin
  P := Point(X,Y);
  WITH Sender AS TWinControl DO
    begin
      Hint := '';
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Controls[N]).BoundsRect, P) THEN
            Hint := TWinControl(Controls[N]).Hint;
      IF Hint = '' THEN
        Application.CancelHint;
    end;
end;

procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
  sbMain.SimpleText := Application.Hint;
end;

procedure TMainForm.FindDialog1Find(Sender: TObject);
begin
  WITH Sender AS TFindDialog DO
    begin
      IF FindText = '' THEN Exit;
      FindWhat := FindText;
      acFindNExtExecute(acFindNext);
    end;
end;

procedure TMainForm.FindDialog1Close(Sender: TObject);
// Remember the find-dialog's position
begin
  WITH Sender AS TFindDialog DO
    FindPos := Position;
end;

procedure TMainForm.AlphaKeyPress(Sender: TObject; var Key: Char);
// Used by on-the-fly text controls that accept only alpha chars
begin
  IF Key >= ' ' THEN
    IF NOT (Key IN ['A'..'Z','a'..'z']) THEN
      Key := #0;
end;

procedure TMainForm.btnFileClick(Sender: TObject);
// Used by on-the-fly file selection buttons
VAR
  num : String;
  idx : Integer;
begin
  // The filter and filename for this button are stored in their
  // arrays, indexed by the same number as the final number of
  // the button's name.
  num := (Sender AS TButton).Name;
  System.Delete(num, 1, Length('cButton'));
  idx := StrToIntDef(Num, -1);
  WITH OpenDialog1 DO
    begin
      IF Idx >= 0 THEN
        begin
          filter   := filters[Idx];
          filename := filfols[Idx];
        end
      ELSE
        begin
          filter   := 'All files|*.*';
          filename := '';
        end;
      // Store the found file in the corresponding label
      IF Execute THEN
        WITH TLabel(Self.FindComponent('cLabel'+num)) DO
          begin
            Caption := Filename;
           IF Idx >= 0 THEN
             filfols[Idx] := filename;
           // Setting the label's tag to 0 tells RR that the
           // necessary user input has taken place
           Tag := 0;
          end;
    end;
end;

procedure TMainForm.btnIconClick(Sender: TObject);
// Used by on-the-fly icon selection buttons
VAR
  num      : String;
  IconIdx  : Integer;
  Idx      : Integer;
  P        : Integer;
  S, fname : String;
begin
  // The filename/index for this button are stored in the
  // filename array, indexed by the same number as the final
  // number of the button's name.
  num := (Sender AS TButton).Name;
  System.Delete(num, 1, Length('cButton'));
  Idx := StrToIntDef(num, -1);
  IF idx >= 0 THEN
    begin
      fName := filfols[Idx];
      // Name has the form "...\foo.dll,42"
      P := LastDelimiter(',', fName);
      IF P > 0 THEN
        begin
          S := fName;
          System.Delete(S, 1, P);
          SetLength(fName, P-1);
          IconIdx := StrToIntDef(S, 0);
        end
      ELSE IconIdx := 0;
    end;
  S := PickIconDlgNu(Self.Handle, fname, IconIdx);
  IF S <> '' THEN
    WITH TLabel(FindComponent('cLabel'+num)) DO
      begin
        Caption := Format('%s,%d', [S, IconIdx]);
        IF Idx >= 0 THEN
          filfols[Idx] := Caption;
        Tag := 0;
      end;
end;

procedure TMainForm.btnFolderClick(Sender: TObject);
// Used by on-the-fly folder selection buttons
VAR
  S     : String;
  fName : String;
  num   : String;
  Idx   : Integer;
begin
  // The folder name for this button is stored in the
  // filename array, indexed by the same number as the final
  // number of the button's name.
  num := (Sender AS TButton).Name;
  System.Delete(num, 1, Length('cButton'));
  Idx := StrToIntDef(num, -1);
  IF Idx >= 0 THEN
    fName := filfols[Idx]
  ELSE
    fName := '';
  IF GetFolder(Self, fName, 'Select folder', S) AND
    ((Pos(':\', S) = 2) OR (Pos('\\', S) = 1)) AND (DirectoryExists(S)) THEN
    WITH TLabel(FindComponent('cLabel'+num)) DO
      begin
        Caption := ExcludeTrailingBackslash(S);
        IF Idx >= 0 THEN
          filFols[Idx] := Caption;
        Tag := 0;
      end;
end;

procedure TMainForm.eBlankChange(Sender: TObject);
// used by on-the-fly text controls that can't be blank
begin
  WITH Sender AS TCustomEdit DO
    IF Text= '' THEN
      Tag := 1
    ELSE Tag := 0;
end;

procedure TMainForm.AddDescription(re : TRichEdit; vTwkID : Integer);
// This routine adds the title, ID, and description to a RichEdit,
// either the visible one or the hidden one used for searching.
begin
  WITH re DO
    begin
      Clear;
      SelAttributes := DefAttributes;
      SelAttributes.Style := [fsUnderline, fsBold];
      SelText := dm1.cdsTwks.FieldByName('Title').Text;
      SelAttributes := DefAttributes;
      SelAttributes.Style := [fsItalic];
      SelText := Format(' (#T%.04d)'#13#10, [vTwkID]);
      SelAttributes := DefAttributes;
      SelAttributes.Style := [];
      SelText := dm1.cdsTwks.FieldByName('Description').Text;
    end;
end;

procedure TMainForm.AddNote(re : TRichEdit);
// This routine adds the personal note (if present) to a RichEdit,
// either the visible one or the hidden one used for searching.
begin
  re.SelStart := re.GetTextLen;
  dm1.cdsNote.First;
  IF dm1.cdsNote.EoF THEN Exit;
  re.SelAttributes.Style := [fsUnderline];
  re.SelText := #13#10#13#10'My notes:';
  re.SelAttributes.Style := [fsItalic];
  re.SelText := ' '+dm1.cdsNote.FieldByName('Note').Text;
end;

procedure TMainForm.AddPlatform(vMask : Word; re : TRichEdit);
// This routine adds the platform line to a RichEdit, possibly
// including a note about administrator privileges
begin
  re.SelAttributes.Style := [fsBold];
  re.SelText := #13#10#13#10'Platforms: ';
  re.SelAttributes.Style := [];
  re.SelText := PlatString(vMask);
  // Under NT family, if the tweak changes anything outside of
  // HKCU we note that admin privilege is needed
  IF (Win32Platform = VER_PLATFORM_WIN32_NT) AND
     (PrivMaskTwk AND (NOT pHKCU) > 0) THEN
    begin
      re.SelText := #13#10'Administrator privileges required';
    end;
end;

procedure TMainForm.ApplyCurrent;
// THIS IS THE BIG ONE! This method applies the current tweak to the
// system, records Undo information, and reports what it did.
const plur : ARRAY[Boolean] OF String = ('', 's');
  waswere : ARRAY[Boolean] OF String = ('was','were');
  cNoNeed  = 4;
  cDidUndo = 2;
  cSuccess = 1;
VAR
  TwkID   : Integer;
  numSpec : Integer;
  Ms      : String;
  PrivNot : Integer;
  numView, numActs, numNoNeed, numOK, numUndo : Integer;

  function NoStartSlash(const S : String) : String;
  begin
    Result := S;
    IF (S <> '') AND (S[1] = '\') THEN
      System.Delete(Result, 1, 1);
  end;

  function DoAddKey(R : TSuperReg2; vRoot: hKey;
    vKey : string) : Integer;
  VAR
    wKey, nKey : String;
    ShouldFree : Boolean;
  begin
    // This is used by the Add Value routine, since it may need to
    // add the key containing the value. If so, it uses the existing
    // registry object.
    ShouldFree := R = nil;
    IF ShouldFree THEN R := TSuperReg2.Create;
    Result := cNoNeed;
    try
      R.RootKey := vRoot;
      R.OpenKey('', False);
      IF R.KeyExists('\'+vKey) THEN Exit; // key already exists
      // Determine what we must do to UNDO this action. Specifically,
      // see just how far in the key-tree we must go. The Undo action
      // will be to delete the first key that doesn't now exist.
      wKey := vKey;
      nKey := wKey;
      REPEAT
        IF R.KeyExists('\'+wKey) THEN Break;
        nKey := wKey;
        wKey := ExtractFileDir(wKey);
      UNTIL wKey = '';
      IF R.CreateKey(vKey) THEN
        begin
          dm1.cdsUndo.ReadOnly := False;
          dm1.cdsUndo.Append;
          dm1.cdsUndo.FieldByName('TwkID').AsInteger    := TwkID;
          dm1.cdsUndo.FieldByName('Root').Text :=
            dm1.cdsData.FieldByName('Root').Text;
          dm1.cdsUndo.FieldByName('Key').Text :=
            NoStartSlash(nKey);
          dm1.cdsUndo.FieldByName('Value').Text         := '';
          dm1.cdsUndo.FieldByName('DataType').AsInteger := 0;
          dm1.cdsUndo.FieldByName('ChangeType').AsInteger := ctDelKey;
          dm1.cdsUndo.FieldByName('Special').Text       := '';
          dm1.cdsUndo.FieldByName('Data').Text          := '';
          dm1.cdsUndo.FieldByName('VerMask').AsInteger  := 0;
          dm1.cdsUndo.Post;
          dm1.cdsUndo.ReadOnly := True;
          Result := cSuccess OR cDidUndo;
        end;
    finally
      IF ShouldFree THEN
        R.Free;
    end;
  end;

  procedure GetLongestValue(vR : TSuperReg2; VAR Value : Integer);
  // If the value data is TOO long, we don't want to store it for
  // undo purposes.
  VAR
    RKI : TRegKeyInfo;
    TS : TStringList;
    N  : Integer;
    K : String;
  begin
    vR.GetKeyInfo(RKI);
    IF RKI.MaxDataLen > Value THEN Value := RKI.MaxDataLen;
    TS := TStringList.Create;
    try
      vR.GetKeyNames(TS);
      K := vR.CurrentPath+'\';
      IF K[1] <> '\' THEN K := '\'+K;
      FOR N := 0 TO TS.COunt-1 DO
        IF vR.OpenKey(K+TS[N], False) THEN
          GetLongestValue(vR, Value);
    finally
      TS.Free;
    end;
  end;

  procedure RecordUndoDelVal(vR : TSuperReg2; const S : String);
  // To undo deleting a value, simply restore it
  VAR DType, DSize : DWORD;
  begin
    IF (RegQueryValueEx(vR.CurrentKey, PChar(S), nil, @DType, nil,
      @DSize) <> ERROR_SUCCESS) THEN Exit;
    dm1.cdsUndo.Append;
    dm1.cdsUndo.FieldByName('TwkID').AsInteger := TwkID;
    dm1.cdsUndo.FieldByName('Root').Text :=
      dm1.cdsData.FieldByName('Root').Text;
    dm1.cdsUndo.FieldByName('Key').Text :=
      NoStartSlash(vR.CurrentPath);
    dm1.cdsUndo.FieldByName('Value').Text           := S;
    dm1.cdsUndo.FieldByName('DataType').AsInteger   := DType;
    dm1.cdsUndo.FieldByName('ChangeType').AsInteger := ctChgVal;
    dm1.cdsUndo.FieldByName('Special').Text         := '';
    IF dType = REG_BINARY THEN
      dm1.cdsUndo.FieldByName('Data').Text := vR.ReadBinString(S,'')
    ELSE
      dm1.cdsUndo.FieldByName('Data').Text := vR.ReadStringSafe(S,'');
    dm1.cdsUndo.FieldByName('VerMask').AsInteger := 0;
    dm1.cdsUndo.Post;
  end;

  procedure RecordUndoAddVal(vR : TSuperReg2; vTyp : Integer; const S : String);
  // To undo adding a value, delete it
  begin
    dm1.cdsUndo.Append;
    dm1.cdsUndo.FieldByName('TwkID').AsInteger      := TwkID;
    dm1.cdsUndo.FieldByName('Root').Text :=
      dm1.cdsData.FieldByName('Root').Text;
    dm1.cdsUndo.FieldByName('Key').Text :=
      NoStartSlash(vR.CurrentPath);
    dm1.cdsUndo.FieldByName('Value').Text           := S;
    dm1.cdsUndo.FieldByName('DataType').AsInteger   := vTyp;
    dm1.cdsUndo.FieldByName('ChangeType').AsInteger := ctDelVal;
    dm1.cdsUndo.FieldByName('Special').Text         := '';
    dm1.cdsUndo.FieldByName('Data').Text            := '';
    dm1.cdsUndo.FieldByName('VerMask').AsInteger    := 0;
    dm1.cdsUndo.Post;
  end;

  procedure RecordUndoDelKey(vR : TSuperReg2);
  // To undo deleting a key, whew! Recreate with subkeys and values
  VAR
    TS : TStringList;
    N  : Integer;
    K : String;
  begin
    dm1.cdsUndo.Append;
    dm1.cdsUndo.FieldByName('TwkID').AsInteger      := TwkID;
    dm1.cdsUndo.FieldByName('Root').Text :=
      dm1.cdsData.FieldByName('Root').Text;
    dm1.cdsUndo.FieldByName('Key').Text :=
      NoStartSlash(vR.CurrentPath);
    dm1.cdsUndo.FieldByName('Value').Text           := '';
    dm1.cdsUndo.FieldByName('DataType').AsInteger   := 0;
    dm1.cdsUndo.FieldByName('ChangeType').AsInteger := ctAddKey;
    dm1.cdsUndo.FieldByName('Special').Text         := '';
    dm1.cdsUndo.FieldByName('Data').Text            := '';
    dm1.cdsUndo.FieldByName('VerMask').AsInteger    := 0;
    dm1.cdsUndo.Post;
    TS := TStringList.Create;
    try
      vR.GetValueNames(TS);
      FOR N := 0 TO TS.Count-1 DO
        RecordUndoDelVal(vR, TS[N]);
      vR.GetKeyNames(TS);
      K := vR.CurrentPath+'\';
      IF K[1] <> '\' THEN K := '\'+K;
      FOR N := 0 TO TS.COunt-1 DO
        IF vR.OpenKey(K+TS[N], False) THEN
          RecordUndoDelKey(vR);
    finally
      TS.Free;
    end;
  end;

  function DoDelKey(vRoot: hKey; const vKey : string) : Integer;
  VAR
    R       : TSuperReg2;
    Longest : Integer;
  begin
    Result := cNoNeed;
    R := TSuperReg2.Create;
    try
      R.RootKey := vRoot;
      IF NOT R.OpenKey(vKey, False) THEN Exit; // key does not exist
      Result := 0;
      Longest := 0;
      GetLongestValue(R, Longest);
      IF Longest > 255 THEN
        begin
          IF MessageBox(Handle, 'Too much data - undo will not be '+
            'possible. Proceed anyway?', 'RegistryRobot',
            MB_YESNO OR MB_ICONQUESTION) <> idYes THEN
              Exit;
        end
      ELSE
        begin
          R.OpenKey('\'+vKey, False);
          dm1.cdsUndo.ReadOnly := False;
          RecordUndoDelKey(R);
          dm1.cdsUndo.ReadOnly := True;
          Result := Result OR cDidUndo;
          IF R.DeleteKey('\'+vKey) THEN
            Result := Result OR cSuccess;
        end;
    finally
      R.Free;
    end;
  end;

  function DoDelValue(vRoot: hKey; const vKey, vVal : string) : Integer;
  VAR R : TSuperReg2;
  begin
    Result := cNoNeed;
    R := TSuperReg2.Create;
    try
      R.RootKey := vRoot;
      IF NOT R.OpenKey(vKey, False) THEN Exit; // key does not exist
      IF NOT R.ValueExists(vVal) THEN Exit; // value does not exist
      Result := 0;
      dm1.cdsUndo.ReadOnly := False;
      RecordUndoDelVal(R, vVal);
      dm1.cdsUndo.ReadOnly := True;
      Result := Result OR cDidUndo;
      IF R.DeleteValue(vVal) THEN
        Result := Result OR cSuccess;
    finally
      R.Free;
    end;
  end;

  function DoChangeValue(vRoot: hKey; vTyp : Integer; const vKey,
    vVal, vDat : string; Tog, TogDef : Boolean; vType : DWord) : Integer;
  VAR
    R       : TSuperReg2;
    oldDat  : String;
    IntVal  : Integer;
  begin
    Result := cNoNeed;
    R := TSuperReg2.Create;
    try
      R.RootKey := vRoot;
      IF Tog THEN
        begin
          R.OpenKey(vKey, True);
          // If the value doesn't exist and the box is not
          // checked, do nothing
          IF (NOT R.ValueExists(vVal)) AND TogDef THEN
            Exit
          ELSE IF R.ReadStringSafe(vVal, '') = vDat THEN
            Exit;
        end
      ELSE
        begin
          DoAddKey(R, R.RootKey, vKey); // Add key if needed
          R.OpenKey(vKey, True);
          dm1.cdsUndo.ReadOnly := False;
          IF R.ValueExists(vVal) THEN
            begin
              IF VType = REG_BINARY THEN
                oldDat := R.ReadBinString(vVal,'')
              ELSE
                olddat := R.ReadStringSafe(vVal, '');
              IF olddat = vDat THEN
                Exit
              ELSE
                RecordUndoDelVal(R, vVal);
            end
          ELSE
            RecordUndoAddVal(R, vTyp, vVal);
          dm1.cdsUndo.ReadOnly := True;
        end;
      Result := cDidUndo;
      IF vType = REG_BINARY THEN
        R.WriteBinStringForce(vVal, vDat)
      ELSE IF vType = REG_DWORD THEN
        begin
          IntVal := StrToIntDef(vDat, 0);
          R.WriteIntegerSafe(vVal, IntVal)
        end
      ELSE
        // DON'T try to write a string "as" an existing binary value.
        // Just blow away the binary.
        R.WriteStringSafeNoBin(vVal, vDat);
      Result := Result OR cSuccess;
    finally
      R.Free;
    end;
  end;

  procedure Report(val, typ : Integer; vTog : Boolean);
  begin
    IF val AND cNoNeed = cNoNeed THEN
      Inc(numNoNeed);
    IF val AND cSuccess = cSuccess THEN
      begin
        Inc(numOK);
        IF (val AND cDidUndo = cDidUndo) OR vTog THEN
          Inc(numUndo);
      end;
  end;

  procedure ProcessActionData;
  VAR
    typ     : Integer;
    dType   : DWORD;
    Root    : hKey;
    rRoot   : String;
    rKey    : String;
    rVal    : String;
    rDat    : String;
    rDat2   : String;
    rSpc    : Integer;
    Tog     : Boolean;
    TogDef  : Boolean;
  begin
    dm1.cdsData.First;
    WHILE NOT dm1.cdsData.Eof DO
      begin
        // Only apply actions that match the Windows and IE versions
        IF dm1.cdsData.FieldByName('VerMask').AsInteger AND
          CurVerMask > 0 THEN
          begin
            Inc(numActs);
            rRoot := dm1.cdsData.FieldByName('Root').Text;
            Root  := RootFor(rRoot);
            IF Root <> 0 THEN
              begin
                WITH dm1.cdsData DO
                  begin
                    typ   := FieldByName('ChangeType').AsInteger;
                    DType := FieldByName('DataType').AsInteger;
                    rKey  := FieldByName('Key').Text;
                    rVal  := FieldByName('Value').Text;
                    rDat  := FieldByName('Data').Text;
                    rSpc  := SpecialNum(FieldByName('Special').Text);
                  end;
                CASE rSpc OF
                  specnone   : ;
                  specdrive  : rDat := GetUserData('E', NumSpec);
                  specfile   : rDat := GetUserData('L', NumSpec);
                  specfolder : rDat := GetUserData('L', NumSpec);
                  specicon   : rDat := GetUserData('L', NumSpec);
                  specmemo   : rDat := GetUserData('M', NumSpec);
                  specnum    : rDat := GetUserData('U', NumSpec);
                  spectext   : rDat := GetUserData('E', NumSpec);
                  spectextb  : rDat := GetUserData('E', NumSpec);
                  speckeyvar : begin
                    rDat2 := VarFromReg(FirstWord(rDat));
                    IF rDat2 = '' THEN
                      Raise(Exception.Create('This action uses data '+
                        'drawn from specific Registry location. '+
                        'That data was not found.'));
                    rKey := StringReplace(rKey, '\\\', '\'+rDat2+'\',
                      [rfReplaceAll]);
                    IF (rKey <> '') AND (rKey[1] = '\') THEN
                      System.Delete(rKey, 1, 1);
                  end;
                  spectoggle : begin
                    FirstWord(rDat);
                    rDat2 := FirstWord(rDat);
                    TogDef := False; 
                    IF GetUserData('C', NumSpec) = '1' THEN
                      rDat := rDat2
                    ELSE TogDef := True;
                    Tog := True;
                  end;
                  specExpand : MyExpand(rDat);
                END;
                CASE typ OF
                  0 : Report(DoAddKey(nil, Root, rKey), typ, Tog);
                  1 : Report(DoChangeValue(Root, DType, rKey, rVal,
                    rDat, Tog, TogDef, DType), typ, Tog);
                  2 : Report(DoDelKey(Root, rKey), typ, Tog);
                  3 : Report(DoDelValue(Root, rKey, rVal), typ, Tog);
                  4 : Inc(NumView);
                end;
              end;
          end;
        dm1.cdsData.Next;
      end;
  end;

begin
  IF ViewOnly THEN Exit; //should not happen
  numView    := 0;
  numActs    := 0;
  numNoNeed  := 0;
  numOK      := 0;
  numUndo    := 0;
  NumSpec    := 0;
  IF tv1.Selected = nil THEN Exit;
  IF tv1.Selected.Data = nil THEN Exit;
  PrivNot := PrivMaskTwk AND (NOT PrivMaskCur);
  IF PrivNot <> 0 THEN
    begin
      MessageBox(Self.Handle, PChar(Format('You do not have the '+
        'necessary permissions to modify some of the keys that '+
        'are referenced by this tweak, specifically %s.'#13#10#13#10+
        'You will need to log on as a user with administrative '+
        'privileges in order to apply this tweak.',
        [KeyNames(PrivNot)])), 'RegistryRobot',
        MB_OK OR MB_ICONSTOP);
      Exit;
    end;
  TwkID := Integer(tv1.Selected.Data);
  // Go through all of the data records and apply them
  ProcessActionData;
  tv1change(tv1, tv1.selected);
  IF NumActs = NumNoNeed THEN
    Ms := Format('This tweak''s %d action%s %s unnecessary.',
      [NumActs, plur[numActs<>1], waswere[NumActs<>1]])
  ELSE IF (NumActs = NumOK) AND (NumActs = NumUndo) THEN
    Ms := Format('This tweak''s %d action%s %s performed '+
      'successfully.', [NumActs, plur[numActs<>1],
      waswere[NumActs<>1]])
  ELSE IF NumOK = 0 THEN
    Ms := Format('This tweak''s %d action%s %s not successful.',
      [NumActs, plur[numActs<>1], waswere[NumActs<>1]])
  ELSE IF NumOK = NumUndo THEN
    Ms := Format('Of this tweak''s %d action%s, %d %s unnecessary '+
      'and %d %s changed successfully.',
    [NumActs, plur[numActs<>1], NumNoNeed, waswere[NumNoNeed<>1],
    NumOK, waswere[numOK<>1]])
  ELSE
    Ms := Format('Of %d action%s, %d %s unnecessary, %d %s '+
    'changed successfully, and %d had undo information stored.',
    [NumActs, plur[numActs<>1], NumNoNeed, waswere[NumNoNeed<>1],
     NumOK, waswere[numOK<>1], NumUndo]);
  MessageBox(Self.Handle, PChar(Ms), 'RegistryRobot', MB_OK OR
    MB_ICONINFORMATION);
end;

procedure TMainForm.ClearFilFols;
VAR N : Integer;
begin
  FOR N := 0 TO 9 DO
    begin
      FilFols[N] := '';
      Filters[N] := '';
    end;
end;

procedure TMainForm.DoSpecial(const Spec, Data, fRoot, fKey,
  fValue : String; VAR NextY, Ctrls : Integer);
// Elements on the Data line are separated by bar (|) characters.
// Originally I considered putting multiple "special" keywords
// on a line as well, but in fact the program does not do so.
VAR
  WorkSpec  : String;
  WorkData  : String;
  PartSpec  : String;
  PartData  : String;
  NextX     : Integer;
  NextYd    : Integer;
  LastComp  : TComponent;

  function RoundUp(val, towhat : Integer) : Integer;
  // Return val rounded up to the nearest multiple of towhat
  begin
    IF val MOD towhat = 0 THEN Result := val
    ELSE result := Succ(val DIV toWhat)*toWhat;
  end;

  procedure AddLeftLabel(const S : String);
  // Add a right-aligned label with its end at NextX. To do this,
  // set it to taRightJustify, set its caption to '', set Left to
  // NextX, and THEN set its actual caption.
  begin
    LastComp := TLabel.Create(Self);
    WITH TLabel(LastComp) DO
      begin
        Name     := 'cLabel'+IntToStr(Ctrls);
        AutoSize := True;
        Parent   := sbCtrls;
        NextX    := NextX + ((5*Screen.PixelsPerInch) DIV 4);
        Alignment := taRightJustify;
        Caption := '';
        Left     := NextX;
        Top      := NextY + 4;
        IF Height > nextYD THEN nextYD := Height;
        Caption  := S;
        NextX    := NextX + 8;
      end;
  end;

  procedure AddLabel(const S : String; req : Boolean);
  // Add a label. If it represents user input (req-uired), get the
  // current value from the Registry.
  VAR vDat : String;
  begin
    IF req THEN
      begin
        vDat := GetCurrentData(fRoot, fKey, fValue, S, False);
        IF vDat = '' THEN vDat := S;
      end
    ELSE vDat := S;
    LastComp := TLabel.Create(Self);
    WITH TLabel(LastComp) DO
      begin
        Name     := 'cLabel'+IntToStr(Ctrls);
        AutoSize := True;
        Parent   := sbCtrls;
        Left     := NextX;
        Top      := NextY;
        IF Height > nextYD THEN nextYD := Height
        ELSE Top := TOp + (NextYD-Height) DIV 2;
        Caption  := vDat;
        NextX    := Roundup(Left + Width, 8) + 8;
        IF req THEN Tag := 1;
      end;
  end;

  procedure AddCheckbox(const S : String; Chk : Boolean);
  begin
    LastComp := TCheckBox.Create(Self);
    WITH TCheckBox(LastComp) DO
      begin
        Name     := 'cCheckBox'+IntToStr(Ctrls);
        Parent   := sbCtrls;
        Left     := NextX;
        Top      := NextY;
        IF Height > nextYD THEN nextYD := Height;
        Caption  := S;
        Width    := Canvas.TextWidth(S) + 32;
        NextX    := Roundup(Left + Width, 8) + 8;
        Checked  := Chk;
      end;
  end;

  procedure AddEdit(Max : Integer; AlphaOnly : Boolean = False;
    AllowBlank : Boolean = true);
  begin
    LastComp := TEdit.Create(Self);
    WITH TEdit(LastComp) DO
      begin
        Name      := 'cEdit'+IntToStr(Ctrls);
        Parent    := sbCtrls;
        Left      := NextX;
        Top       := NextY;
        IF Height > nextYD THEN nextYD := Height;
        Text      := GetCurrentData(fRoot, fKey, fValue, '', False);
        MaxLength := Max;
        IF Max = 1 THEN
          Width := 32
        ELSE
          begin
            Width     := sbCtrls.ClientWidth-Left-8;
            Anchors   := [akLeft, akTop, akRight];
          end;
        IF AlphaOnly THEN
          begin
            CharCase   := ecUpperCase;
            OnKeyPress := AlphaKeyPress;
          end;
        IF NOT AllowBlank THEN
          begin
            IF Text = '' THEN
              Tag := 1;
            OnChange := eBlankChange;
          end;
      end;
  end;

  procedure AddView(const S : String);
  begin
    LastComp := TEdit.Create(Self);
    WITH TEdit(LastComp) DO
      begin
        Name      := 'cView'+IntToStr(Ctrls);
        ReadOnly  := True;
        Color     := clBtnFace;
        Parent    := sbCtrls;
        Left      := NextX;
        Top       := NextY;
        IF Height > nextYD THEN nextYD := Height;
        Text      := S;
        Width     := sbCtrls.ClientWidth-Left-8;
        Anchors   := [akLeft, akTop, akRight];
        Tag := 2;
      end;
  end;

  procedure AddBrowse(which : Integer);
  begin
    LastComp := TButton.Create(Self);
    WITH TButton(LastComp) DO
      begin
        Name     := 'cButton'+IntToStr(Ctrls);
        Parent   := sbCtrls;
        Left     := NextX;
        Top      := NextY;
        Width    := btnApply.Width;
        Height   := btnApply.Height;
        IF Height > nextYD THEN nextYD := Height;
        Caption  := 'Browse...';
        NextX    := Roundup(Left + Width, 8) + 8;
        CASE which OF
          specFile   : OnClick := btnFileClick;
          specFolder : OnClick := btnFolderClick;
          specIcon   : OnClick := btnIconClick;
        END;
      end;
    FilFols[Ctrls] := Expando(GetCurrentData(fRoot, fKey, fValue,
      '', False));
  end;

  procedure AddFilter(const S : String);
  begin
    filters[Ctrls] := S;
  end;

  procedure AddMemo(Max : Integer);
  begin
    LastComp := TMemo.Create(Self);
    WITH TMemo(LastComp) DO
      begin
        Name      := 'cMemo'+IntToStr(Ctrls);
        Parent    := sbCtrls;
        Left      := NextX;
        Top       := NextY;
        Text      := GetCurrentData(fRoot, fKey, fValue, '', False);
        MaxLength := Max;
        Width     := sbCtrls.ClientWidth-Left-8;
        Anchors   := [akLeft, akTop, akRight];
        Height    := 64;
        IF Height > nextYD THEN nextYD := Height;
        WordWrap  := True;
        ScrollBars := ssVertical;
        IF Text = '' THEN
          Tag := 1;
        OnChange := eBlankChange;
      end;
  end;

  procedure AddUpDown(VAR sData : String);
  VAR
    vEdit   : TEdit;
    vUpDown : TUpDown;
    sDat    : String;
    Def     : Integer;
  begin
    vEdit := TEdit.Create(Self);
    WITH vEdit DO
      begin
        Name   := 'cEdit'+IntToStr(Ctrls);
        Parent := sbCtrls;
        Width  := 50;
        Left   := NextX;
        Top      := NextY;
        IF Height > nextYD THEN nextYD := Height;
      end;
    vUpDown := TUpDown.Create(Self);
    WITH vUpDown DO
      begin
        Name        := 'cUpDown'+IntToStr(Ctrls);
        Parent      := sbCtrls;
        Min         := StrToIntDef(FirstWord(sData), 0);
        Max         := StrToIntDef(FirstWord(sData), 32767);
        Increment   := StrToIntDef(FirstWord(sData), 1);
        Def         := StrToIntDef(FirstWord(sData),
          (((Max+Min) DIV 2) DIV Increment)*Increment);
        IF Def < Min THEN Def := Min;
        IF Def > Max THEN Def := Max;
        sDat := GetCurrentData(fRoot, fKey, fValue, '', False);
        Position    := StrToIntDef(sDat, Def);
        Associate   := vEdit;
        AlignButton := udRight;
      end;
    LastComp := vUpDown;
  end;

begin
  IF Spec = '' THEN Exit;
  WorkSpec := Spec;
  PartSpec := FirstWord(WorkSpec);
  WorkData := Data;
  PartData := FirstWord(WorkData);
  NextX    := btnApply.Left;
  NextYd   := 0;
  CASE SpecialNum(PartSpec) OF
    specnone   : Exit;
    specdrive  : begin
      AddLeftLabel(PartData);
      AddEdit(1, true, false);
    end;
    specfile   : begin
      AddBrowse(specfile);
      AddLabel(PartData, true);
      AddFilter(FirstWord(WorkData)+'|'+
        FirstWord(WorkData));
    end;
    specfolder : begin
      AddBrowse(specfolder);
      AddLabel(PartData, true);
    end;
    specicon   : begin
      AddBrowse(specIcon);
      AddLabel(PartData, true);
    end;
    specmemo   : begin
      AddLeftLabel(PartData);
      AddMemo(4096);
    end;
    specnum    : begin
      AddLeftLabel(PartData);
      AddUpDown(WorkData);
    end;
    spectext   : begin
      AddLeftLabel(PartData);
      AddEdit(255);
    end;
    spectextb  : begin
      AddLeftLabel(PartData);
      AddEdit(255, false, false);
    end;
    specview : begin
      AddLeftLabel(PartData);
      AddView(GetCurrentData(fRoot, fKey, fValue, '', False));
    end;
    specToggle : begin
      AddCheckbox(PartData, FirstWord(WorkData) =
        GetCurrentData(fRoot, fKey, fValue, '', False));
    end;
    specKeyVar, specExpand : begin
      // no special control
    end;
  END;
  Inc(Ctrls);
  Inc(NextY, NextYd + 8);
  DoSpecial(WorkSpec, WorkData, fRoot, fKey, fValue, NextY, Ctrls);
end;

procedure TMainForm.FillDetail;
// Build the detail display
VAR
  fdRoot, fdKey, fdVal, fdData, shoVal, shoDat, shokey : String;
  tog1, tog2          : String;
  NumSpec, typ, SpecX : Integer;
  rBin                : Boolean;
  CDS                 : TClientDataSet;

  procedure AddText(const S: String; styl: TFontStyles;
    Cour : Boolean);
  begin
    IF Cour THEN
      reDetail.SelAttributes.Name := 'Courier New'
    ELSE
      reDetail.SelAttributes.Name := reDetail.Font.Name;
    reDetail.SelAttributes.Style := styl;
    reDetail.SelText             := S;
  end;

  procedure DoViewOnly;
  VAR Plat : Integer;
  begin
    IF ViewOnly THEN
      begin
        Plat := CDS.FieldByName('VerMask').AsInteger;
        AddText(' Platforms: '+ PlatString(Plat), [fsItalic], False);
        AddText('', [], False);
      end;
  end;

begin
  reDetail.Clear;
  reDetail.Paragraph.FirstIndent := 8;
  reDetail.Paragraph.RightIndent := 8;
  reDetail.DefAttributes.Name := reDetail.Font.Name;
  reDetail.DefAttributes.Size := reDetail.Font.Size;
  NumSpec := 0;
  AddText('', [], False); // "prime" the richedit
  IF IsUndo AND (NOT ViewOnly) THEN
    CDS := dm1.cdsUndo
  ELSE
    CDS := dm1.cdsData;
  WITH CDS DO
    begin
      First;
      WHILE NOT EoF DO
        begin
          // If this is a DO, not udno, and it's not ViewOnly, and
          // the current mask doesn't match this action's mask,
          // then skip to the next
          IF (NOT IsUndo) AND (NOT ViewOnly) AND
            (CurVerMask AND FieldByName('VerMask').AsInteger =0) THEN
            begin
              Next;
              Continue;
            end;
          AddText(#13#10#13#10, [], False);
          typ := FieldByName('ChangeType').AsInteger;
          CASE typ OF
            0 : AddText('Add Registry key ', [], False);
            2 : AddText('Delete Registry key ', [], False);
            ELSE AddText('In Registry key ', [], False);
          END;
          SpecX  := SpecialNum(FieldByName('Special').Text);
          fdRoot := FieldByName('Root').Text;
          fdKey  := FieldByName('Key').Text;
          fdData := FieldByName('Data').Text;
          IF SpecX = specExpand THEN
            MyExpand(fdData);
          rBin := FieldByName('DataType').AsInteger = 3;
          IF SpecX = specKeyVar THEN
          // Special - get data from another spot in the Registry
          // to modify the KEY
            begin
              shoKey := StringReplace(fdKey, '\\\', '[VAR]\',
                [rfReplaceAll]);
              AddText(Format('%s\%s', [fdRoot, shoKey]), [], True);
              shoDat := FirstWord(fdData);
              tog1   := VarFromReg(ShoDat);
              AddText(Format(' (where [VAR] is replaced by "%s", '+
                'found at %s)', [tog1, shoDat]),[], False);
              IF tog1='' THEN
                fdKey := '*ERROR*'
              ELSE
                begin
                  fdKey := StringReplace(fdKey, '\\\', '\'+tog1+'\',
                    [rfReplaceAll]);
                  IF (fdKey <> '') AND (fdKey[1] = '\') THEN
                    System.Delete(fdKey, 1, 1);
                end;
            end
          ELSE
            AddText(Format('%s\%s', [fdRoot, fdKey]), [], True);
          fdVal  := FieldByName('Value').Text;
          shoVal := fdVal;
          IF shoVal = '' THEN shoVal := '(Default)';
          CASE typ OF
            1 : begin
              AddText(', add or change the value named ', [], False);
              AddText(shoVal, [], True);
              AddText(', changing its current data of ', [], False);
              ShoDat := Shorten(GetCurrentData(fdRoot, fdKey, fdVal,
                '(none)', rBin));
              IF shoDat = '' THEN shoDat := '(none)';
              AddText(shoDat, [], True);
              AddText(' to ',[], False);
            end;
            3 : begin
              AddText(', delete the value named ', [], False);
              AddText(shoVal, [], True);
              AddText('.', [], False);
              DoViewOnly;
              Next;
              Continue;
            end;
            4 : begin
              AddText(', view the value named ', [], False);
              AddText(shoVal, [], True);
              AddText('.', [], False);
              Typ := 4;
              DoViewOnly;
              Next;
              Continue;
            end;
            ELSE begin
              DoViewOnly;
              Next;
              Continue;
            end;
          END;
          // We only reach this point for an add/change key
          CASE SpecX OF
            specNone, specKeyVar, specExpand : begin
              IF fdData = '' THEN fdData := '(none)';
              AddText(fdData, [], True);
              AddText('.', [], False);
            end;
            specToggle : begin
              tog2 := fdData;
              tog1 := FirstWord(tog2);
              tog1 := FirstWord(tog2);
              AddText(tog1, [], True);
              AddText(' if checked, ',[], False);
              AddText(tog2, [], True);
              AddText(' if not.',[], False);
            end;
            ELSE AddText('a user-specified value.', [], False);
          END;
          DoViewOnly;
          Next;
        end;
    end;
  // Now that we know what kind of items we have, go back and
  // insert the header line
  reDetail.SelStart := 0;
  IF IsUndo THEN
    begin
      AddText('Undo action:', [fsUnderline], False);
    end
  ELSE
    begin
      IF typ=4 THEN
        AddText('(View only; no action)', [fsUnderline], False)
      ELSE
        AddText('DO IT action:', [fsUnderline], False);
    end;
end;

function TMainForm.GetCurrentData(vRoot, vKey, vVal, vDef : String;
  bin : Boolean) : String;
begin
  Result := vDef;
  WITH TSuperReg2.Create DO
  try
    RootKey := RootFor(vRoot);
    IF RootKey = 0 THEN Exit;
    IF OpenKeyReadOnly(vKey) THEN
      IF bin THEN
        Result := ReadBinString(vVal,'')
      ELSE
        Result := ReadStringSafe(vVal, vDef);
  finally
    Free;
  end;
end;


function TMainForm.GetUserData(typ : Char;
  VAR NumSpec : Integer) : String;
// Get the data from tweak-specific controls
  function FromCheckbox : String;
  VAR vCheckbox : TCheckbox;
  begin
    vCheckbox := TCheckbox(FindComponent('cCheckbox'+
      IntToStr(NumSpec)));
    IF vCheckbox = nil THEN
      Result := '0'
    ELSE
      begin
        IF vCheckBox.Checked THEN
          Result := '1'
        ELSE Result := '0';
      end;
    Inc(NumSpec);
  end;

  function FromLabel : String;
  VAR vLabel : TLabel;
  begin
    vLabel := TLabel(FindComponent('cLabel'+IntToStr(NumSpec)));
    IF vLabel = nil THEN
      Result := ''
    ELSE
      Result := vLabel.Caption;
    Inc(NumSpec);
  end;

  function FromUpDown : String;
  VAR vUpDown : TUpDown;
  begin
    vUpDown := TUpDown(FindComponent('cUpDown'+IntToStr(NumSpec)));
    IF vUpDown = nil THEN
      Result := ''
    ELSE
      Result := IntToStr(vUpDown.Position);
    Inc(NumSpec);
  end;

  function FromEdit : String;
  VAR vEdit : TEdit;
  begin
    vEdit := TEdit(FindComponent('cEdit'+IntToStr(NumSpec)));
    IF vEdit = nil THEN
      Result := ''
    ELSE
      Result := vEdit.Text;
    Inc(NumSpec);
  end;

  function FromMemo : String;
  VAR vMemo : TMemo;
  begin
    vMemo := TMemo(FindComponent('cMemo'+IntToStr(NumSpec)));
    IF vMemo = nil THEN
      Result := ''
    ELSE
      Result := vMemo.Text;
    Inc(NumSpec);
  end;
begin
  CASE typ OF
    'C' : Result := FromCheckbox;
    'L' : Result := FromLabel;
    'U' : Result := FromUpDown;
    'E' : Result := FromEdit;
    'M' : Result := FromMemo;
    ELSE Result := '';
  END;
end;

procedure TMainForm.LoadTree;
// Loading a TTreeView directly can be tediously slow. Instead,
// we build an in-memory structure representing the items, with
// their categories and subcategories, and then add them to the
// treeview in a logical fashion.
VAR
  TScat : TStringList; // list of categories
  TSsub : TStringList; // list of subcategories
  TSttl : TStringList; // list of tweaks
  S     : String;
  TwkID : Integer;
  Icat  : Integer; // index of categories
  Isub  : Integer; // index of subcategories
  Ittl  : Integer; // index of tweaks
  root  : TTreeNode; // root node
  Tcat  : TTreeNode; // node for category
  Tsub  : TTreeNode; // node for subcategory
  Tttl  : TTreeNode; // node for tweak
  allMask  : DWord;
  NotForMe : Boolean;
begin
  tv1.Items.Clear;
  root  := tv1.Items.Add(nil, 'Categories');
  TScat := TStringList.Create;
  TScat.Sorted := True;
  try
    WITH dm1.cdsTwks DO
      begin
        First;
        WHILE NOT EoF DO
          begin
            TwkID := FieldByName('TwkID').AsInteger;
            // If it is to be hidden and we're not in View Only
            // mode, skip it
            IF FieldByName('Hide').AsBoolean AND (NOT ViewOnly) THEN
              begin
                Next;
                Continue;
              end;
            allMask := 0;
            // Build a mask from ALL the actions
            WITH dm1.cdsData DO
              begin
                First;
                WHILE NOT EoF DO
                  begin
                    allMask := allMask OR DWORD(FieldByName(
                      'VerMask').AsInteger);
                    Next;
                  end;
              end;
            S := FieldByName('Category').Text;
            NotForMe := CurVerMask AND allMask = 0;
            // If the mask doesn't match the current system and we
            // are not in View Only mode, skip it
            IF NotForMe AND (NOT ViewOnly) THEN
              begin
                Next;
                Continue;
              end;
            // Get the index of the current category. If not yet
            // listed, add it, with its sub-list
            Icat := TScat.IndexOf(S);
            IF Icat < 0 THEN
              begin
                TSsub := TStringList.Create;
                TSsub.Sorted := True;
                Icat := TScat.AddObject(S, TSsub);
              end
            ELSE TSSub := TStringList(TScat.Objects[ICat]);
            S := FieldByName('SubCat').Text;
            Isub := TSsub.IndexOf(S);
            // Get the index of the current subcat. If not present,
            // add it with its list of tweaks
            IF Isub < 0 THEN
              begin
                TSttl := TStringList.Create;
                TSttl.Sorted := True;
                TSttl.Duplicates := dupAccept;
                Isub := TSsub.AddObject(S, TSttl);
              end
            ELSE TSttl := TStringList(TSsub.Objects[Isub]);
            S := FieldByName('Title').Text;
            IF NotForMe THEN
              TSttl.AddObject(S, Pointer(-TwkID))
            ELSE
              TSttl.AddObject(S, Pointer(TwkID));
            Next;
          end;
      end;
    // Now build the tree
    FOR Icat := 0 TO TScat.Count-1 DO
      begin
        // Add a category
        Tcat := tv1.Items.AddChild(root, TScat[Icat]);
        TCat.StateIndex := 2;
        TSsub := TStringList(TScat.Objects[Icat]);
        FOR iSub := 0 TO TSsub.Count-1 DO
          begin
            // If subcat is not blank, add a subcategory
            IF TSsub[Isub] <> '' THEN
              begin
                Tsub := tv1.Items.AddChild(Tcat, TSsub[Isub]);
                TSub.StateIndex := 2;
              end
            ELSE
              // Otherwise, point to the category
              Tsub := TCat;
            TSttl := TStringList(TSsub.Objects[Isub]);
            // Now add the items
            FOR Ittl := 0 TO TSttl.Count-1 DO
              begin
                TwkID := Integer(TSttl.Objects[Ittl]);
                Tttl := tv1.Items.AddChildObject(Tsub, TSttl[Ittl],
                  Pointer(Abs(TwkID)));
                // Icon 4 is for "not for me" items - red
                IF Abs(TwkID) <> TwkID THEN
                  Tttl.StateIndex := 4
                ELSE
                  Tttl.StateIndex := 1;
                IF Abs(TwkID) = HeldID THEN
                  tv1.Selected := Tttl;
              end;
          end;
      end;
    root.Expand(false);
  finally
    HeldID := -1;
    // Now clean up all those lists!
    FOR Icat := TSCat.Count-1 DOWNTO 0 DO
      begin
        TSsub := TStringList(TScat.Objects[iCat]);
        FOR ISub := TSsub.Count-1 DOWNTO 0 DO
          begin
            TSttl := TStringList(TSsub.Objects[iSub]);
            TSttl.Free;
          end;
        TSsub.Free;
      end;
    TScat.Free;
  end;
  IF tv1.Selected = nil THEN
    acNextTweakExecute(acNextTweak);
end;

procedure TMainForm.ShareVertical;
// Try to share the vertical space among the three panes.
VAR
  ConGets, DetGets, DesGets : Integer;
  MainH, SubH : Integer;
begin
  ConGets := gbCtrls.Height;
  DetGets := gbDetail.Height;
  DesGets := gbDesc.Height;
  MainH := pnlDesc.ClientHeight - hsplitDD.Height;
  SubH := DetGets+ConGets;
  // If any of the items doesn't have the space it wants...
  IF (ConGets < ConNeeds) OR (DetGets < DetNeeds) OR
    (DesGets < DesNeeds) OR (SubH+DesGets > MainH)THEN
    begin
      // IF there's room for all three, give controls and details
      // what they need and give the rest to Description.
      IF ConNeeds + DesNeeds + DetNeeds < MainH THEN
        begin
          ConGets := ConNeeds;
          DetGets := DetNeeds;
          DesGets := MainH - ConGets - DetGets;
        end
      // If there's enough to give controls and description their
      // needs and details no less than its minimum, give controls
      // and descrption what they need and give the rest to detail
      ELSE IF ConNeeds + DesNeeds + gbDetail.Tag < MainH THEN
        begin
          ConGets := ConNeeds;
          DesGets := DesNeeds;
          DetGetS := MainH - ConGets - DetGets;
        end
      // If there's enough for controls plus the minimum of the other
      // two, give controls what it needs, detail its minimum,
      // and Description the rest
      ELSE IF ConNeeds + gbDesc.Tag + gbDetail.Tag < MainH THEN
        begin
          ConGets := ConNeeds;
          DetGets := gbDetail.Tag;
          DesGets := MainH - ConGets - DetGets;
        end
      ELSE
        // Otherwise, give details and description their minimums
        // and controls the rest. Whew!
        begin
          DesGets := gbDesc.Tag;
          DetGets := gbDetail.Tag;
          ConGets := MainH - DesGets - DetGets;
        end;
    end;
  pnlDetCon.Height := MainH - DesGets;
  gbCtrls.Height := ConGets;
  reDesc.Refresh;
  reDetail.Refresh;
  hSplitCD.Top := gbCtrls.Top-1;
  hSplitDD.Top := pnlDetCon.Top-1;
end;

function TMainForm.ToNextTweak(TN : TTreeNode): TTreeNode;
// Go to the next tweak, traversing the tree until you find a
// node that IS a tweak. Because the tree is never more than
// three levels below the root, we don't bother with recursion.

  function GetFirstTip(vTN : TTreeNode) : TTreeNode;
  begin
    Result := vTN;
    WHILE (Result <> nil) AND (Result.Data = nil) DO
      Result := Result.GetFirstChild;
  end;

begin
  IF TN = nil THEN TN := tv1.Items.GetFirstNode;
  IF TN.Data = nil THEN
    Result := GetFirstTip(TN)
  ELSE
    begin
      Result := TN.GetNextSibling;
      // Is the next sibling a tweak? Then GO!
      IF (Result <> nil) AND (Result.Data <> nil) THEN Exit;
      // If not, take the first tip it contains
      IF Result <> nil THEN Result := GetFirstTip(Result);
      // Does it exist? Then go!
      IF Result <> nil THEN Exit;
      // If we're just below the root, then GO!
      IF TN.Parent = nil THEN Exit;
      // Get the first tweak of the parent's next sibling
      Result := GetFirstTip(TN.Parent.GetNextSibling);
      // Got it? Then go!
      IF Result <> nil THEN Exit;
      // If we're two levels below the root, then GO!
      IF TN.Parent.Parent = nil THEN Exit;
      Result := GetFirstTip(TN.Parent.Parent.GetNextSibling);
      IF Result <> nil THEN Exit;
      IF TN.Parent.Parent.Parent = nil THEN Exit;
      Result := GetFirstTip(TN.Parent.Parent.Parent.GetNextSibling);
      IF Result <> nil THEN Exit;
    end;
end;

function TMainForm.ToPrevTweak(TN : TTreeNode): TTreeNode;
// Go to the previous tweak, traversing the tree until you find a
// node that IS a tweak. Because the tree is never more than
// three levels below the root, we don't bother with recursion.

  function GetLastTip(vTN : TTreeNode) : TTreeNode;
  begin
    Result := vTN;
    WHILE (Result <> nil) AND (Result.Data = nil) DO
      Result := Result.GetLastChild;
  end;

begin
  IF TN = nil THEN TN := tv1.Items[tv1.Items.Count-1];
  IF TN.Data = nil THEN
    Result := GetLastTip(TN.GetPrevSibling)
  ELSE
    begin
      Result := TN.GetPrevSibling;
      IF (Result <> nil) AND (Result.Data <> nil) THEN Exit;
      IF Result <> nil THEN Result := GetLastTip(Result);
      IF Result <> nil THEN Exit;
      IF TN.Parent = nil THEN Exit;
      Result := GetLastTip(TN.Parent.GetPRevSibling);
      IF Result <> nil THEN Exit;
      IF TN.Parent.Parent = nil THEN Exit;
      Result := GetLastTip(TN.Parent.Parent.GetPrevSibling);
      IF Result <> nil THEN Exit;
      IF TN.Parent.Parent.Parent = nil THEN Exit;
      Result := GetLastTip(TN.Parent.Parent.Parent.GetPrevSibling);
      IF Result <> nil THEN Exit;
    end;
end;

procedure TMainForm.UndoCurrent;
VAR
  typ   : Integer;
  Root  : hKey;
  rKey  : String;
  rVal  : String;
  rDat  : String;

  procedure uDoAddKey(vRoot: hKey; vKey : string);
  begin
    WITH TSuperReg2.Create DO
    try
      RootKey := vRoot;
      OpenKey(vKey, True);
    finally
      Free;
    end;
  end;

  procedure uDoChangeValue(vRoot: hKey; const vKey, vVal,
    vDat : string; vTyp : Integer);
  begin
    WITH TSuperReg2.Create DO
    try
      RootKey := vRoot;
      OpenKey(vKey, True);
      CASE vTyp OF
        REG_DWORD_BIG_ENDIAN,
        REG_DWORD  : WriteIntegerSafe(vVal, StrToIntDef(vDat, 0));
        REG_BINARY : WriteBinStringForce(vVal, vDat);
        ELSE         WriteStringSafe(vVal, vDat);
      END;
    finally
      Free;
    end;
  end;

  procedure uDoDelKey(vRoot: hKey; const vKey : string);
  VAR TS : TStringList;
  begin
    TS := TStringList.Create;
    try
      WITH TSuperReg2.Create DO
      try
        RootKey := vRoot;
        GetValueNames(TS);
        IF TS.Count = 0 THEN
          DeleteKey(vKey);
      finally
        Free;
      end;
    finally
      TS.Free;
    end;
  end;

  procedure uDoDelValue(vRoot: hKey; const vKey, vVal : string);
  begin
    WITH TSuperReg2.Create DO
    try
      RootKey := vRoot;
      IF OpenKey(vKey, False) THEN
        DeleteValue(vVal);
    finally
      Free;
    end;
  end;

begin
  IF ViewOnly THEN Exit; // should not happen
  IF tv1.Selected = nil THEN Exit;
  IF tv1.Selected.Data = nil THEN Exit;
  dm1.cdsUndo.First;
  WHILE NOT dm1.cdsUndo.Eof DO
    begin
      Root := RootFor(dm1.cdsUndo.FieldByName('Root').Text);
      IF Root <> 0 THEN
        begin
          typ := dm1.cdsUndo.FieldByName('ChangeType').AsInteger;
          rKey := dm1.cdsUndo.FieldByName('Key').Text;
          rVal := dm1.cdsUndo.FieldByName('Value').Text;
          rDat := dm1.cdsUndo.FieldByName('Data').Text;
          CASE typ OF
            0 : uDoAddKey(Root, rKey);
            1 : uDoChangeValue(Root, rKey, rVal, rDat,
              dm1.cdsUndo.FieldByName('DataType').AsInteger);
            2 : uDoDelKey(Root, rKey);
            3 : uDoDelValue(Root, rKey, rVal);
            4 : ; //View value (shouldn't happen)
          end;
        end;
      dm1.cdsUndo.ReadOnly := False;
      dm1.cdsUndo.Delete;
      dm1.cdsUndo.ReadOnly := True;
    end;
  tv1change(tv1, tv1.selected);
end;

function TMainForm.VarFromReg(const S : String) : String;
// Used in ApplyCurrent and FillDetail to get a key when the
// special type is "readkeyvar".
VAR
  WorkS : String;
  sVal  : String;
  P     : Integer;
begin
  Result := '';
  WorkS := S;
  WITH TSuperReg2.Create DO
  try
    RootKey := RootFor(Copy(WorkS, 1, 4));
    IF RootKey = 0 THEN Exit;
    System.Delete(WorkS, 1, 5);
    P := Pos('\\', WorkS);
    IF P = 0 THEN Exit;
    sVal := WorkS;
    System.Delete(sVal, 1, P+1);
    SetLength(WorkS, P-1);
    IF OpenKeyReadOnly(WorkS) THEN
      Result := ReadStringSafe(sVal, '');
  finally
    Free;
  end;
end;

procedure TMainForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
  WITH Msg.MinMaxInfo.ptMinTrackSize DO
    begin
      X := 620;
      Y := 480;
    end;
  Msg.Result := 0;
end;

end.


