unit platu;

// Copyright  2002 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFormPlat = class(TForm)
    w95: TCheckBox;
    w98: TCheckBox;
    wME: TCheckBox;
    wNT: TCheckBox;
    w20: TCheckBox;
    wXP: TCheckBox;
    wDU: TCheckBox;
    ie4: TCheckBox;
    ie5: TCheckBox;
    ie6: TCheckBox;
    btnOK: TButton;
    btnCancel: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetData(const vS : String; Pt : TPoint);
    function GetData : String;
  end;

var
  FormPlat: TFormPlat;

implementation

{$R *.dfm}
const
  c95 = $0001;
  c98 = $0002;
  cME = $0004;
  cNT = $0008;
  c20 = $0010;
  cXP = $0020;
  cI4 = $0100;
  cI5 = $0200;
  cI6 = $0400;
  cWD = $0800; //WDU

{ TFormPlat }

function TFormPlat.GetData : String;
VAR Value : Integer;
begin
  Value := 0;
  IF WDU.Checked THEN Value := Value OR cWD;
  IF W95.Checked THEN Value := Value OR c95;
  IF W98.Checked THEN Value := Value OR c98;
  IF WME.Checked THEN Value := Value OR cME;
  IF WNT.Checked THEN Value := Value OR cNT;
  IF W20.Checked THEN Value := Value OR c20;
  IF WXP.Checked THEN Value := Value OR cXP;
  IF IE4.Checked THEN Value := Value OR cI4;
  IF IE5.Checked THEN Value := Value OR cI5;
  IF IE6.Checked THEN Value := Value OR cI6;
  Result := IntToStr(Value);
end;

procedure TFormPlat.SetData(const vS: String; Pt : TPoint);
VAR Value : Integer;
begin
  Self.Top := Pt.Y;
  Self.Left := Pt.X;
  IF Self.Top + Self.Height > Screen.Height THEN
    Self.Top := Screen.Height - Self.Height;
  IF Self.Left + Self.Width > Screen.Width THEN
    Self.Left := Screen.Width - Self.Width;
  Value := StrToIntDef(vS, 0);
  WDU.Checked := Value AND cWD > 0;
  W95.Checked := Value AND c95 > 0;
  W98.Checked := Value AND c98 > 0;
  WME.Checked := Value AND cME > 0;
  WNT.Checked := Value AND cNT > 0;
  W20.Checked := Value AND c20 > 0;
  WXP.Checked := Value AND cXP > 0;
  IE4.Checked := Value AND cI4 > 0;
  IE5.Checked := Value AND cI5 > 0;
  IE6.Checked := Value AND cI6 > 0;
end;

end.
